freeslot("SPR_LOAE", "sfx_loaded", "sfx_loacrt", "S_HALOBOMB", "sfx_utstr", "sfx_golhal", "sfx_golhl2")

freeslot("SPR_VZAN")

for i = 1, 6
	freeslot("sfx_volza"..i)
end


BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "A Mighty Power",
  description = {"A Great Power wants", "to see your strength..."},
  level = 99,
  music = "GREPWR",
  time = TICRATE*60*55,
  items = {{"tr_tear-allbalm", 50}, {"tr_spcharge3", 50}, {"tr_stablet", 50}, {"tr_curiabalm", 30}, {"tr_recuriabalm", 20}, {"tr_revbalm", 30}, {"tr_celbalm", 20}, {"hypercombiring", 30}, {"soma", 5}},
  waves = {
			{"loa"},
		},
}

enemyList["loa"] = {
		name = "Loa Erebonius",
		skillchance = 100,	
		level = 100,
		hp = 10000,
		sp = 9999,
		strength = 80,
		magic = 80,
		endurance = 60,
		luck = 60,
		agility = 60,
		melee_natk = "tr_clawstrike",	
		thinker = generalEnemyThinker,
		scale = FRACUNIT*2,
		boss = true,
		endboss = true,
		turns = 2,

		anim_stand = 		{SPR_LOAE, A, 4},				-- standing
		anim_stand_hurt =	{SPR_LOAE, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_LOAE, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_LOAE, A, 4},				-- guarding
		anim_move =			{SPR_LOAE, A, 4},	-- moving
		anim_run =			{SPR_LOAE, A, 4},	-- guess what
		anim_atk =			{SPR_LOAE, A, 4},			-- attacking
		anim_aoa_end =		{SPR_LOAE, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_LOAE, A, 4},				-- taking damage
		anim_getdown =		{SPR_LOAE, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LOAE, A, 4},					-- is down
		anim_getup =		{SPR_LOAE, A, 4},			-- gets up from down
		anim_death =		{SPR_LOAE, A, 4},					-- dies
		anim_revive =		{SPR_LOAE, A, 4},			-- gets revived
		anim_evoker =		{SPR_LOAE, A, 4},
		anim_evoker_shoot = {SPR_LOAE, A, 4},
		
		vfx_crit = {"sfx_loacrt"},
		
		hudcutin = "LOAE_A",	-- cut in

		
		skills = {"tr_clawstrike", "tr_vel-da-doop", "tr_vilna-ya", "tr_ark-zok-onkeim", "tr_volzello-anaia", "tr_van-ku-oh", "dekaja", "dekunda", "tr_calamitous_blast", "tr_golden halo", "tr_sol_eruption", "tr_lost_eden", "tr_statusnull", "tr_finaltrialmap", "nuke amp", "curse amp", "diamondcutter", "almighty amp"},
			
		deathanim = function(mo)

						mo.deathtimer = $ and $+1 or 1

						if mo.deathtimer == 1
							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									S_FadeOutStopMusic(200, p)
								end
							end
							
							mo.basecoords = {mo.x, mo.y, mo.z}
							mo.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY							

						elseif mo.deathtimer == 20 
							S_StartSound(nil, sfx_loaded)
						end	

						if mo.deathtimer > 20
						and mo.deathtimer < 220
							local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
							thok.state = S_INVISIBLE
							thok.scale = FRACUNIT*7
							summonAura(thok, SKINCOLOR_MAGENTA)
							thok.tics = 2
						end	

							
						if mo.deathtimer > 20
						and mo.deathtimer < 220

							if leveltime & 1
								for i = 1, 2

									local s = P_SpawnMobj(mo.x, mo.y, mo.z + mo.scale*32, MT_DUMMY)
									if i == 1
										s.z = $ - mo.scale*32
									else
										s.z = $ + mo.scale*100
									end

									s.sprite = SPR_SLAS
									s.frame = K+(i-1) | FF_FULLBRIGHT | TR_TRANS30
									s.color = SKINCOLOR_MAGENTA
									s.scale = FRACUNIT/8
									s.destscale = FRACUNIT*20
									s.scalespeed = FRACUNIT/2
									s.tics = TICRATE/2

									s.momx = P_RandomRange(-2, 2)*FRACUNIT
									s.momy = P_RandomRange(-2, 2)*FRACUNIT
									s.momz = P_RandomRange(-2, 2)*FRACUNIT

								end
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 220
							if not (mo.deathtimer%4)
								local s = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*15, MT_DUMMY)
								s.color = SKINCOLOR_WHITE
								s.flags = MF_NOBLOCKMAP
								s.state = S_MEGISTAR1
								s.scale = FRACUNIT*10
								localquake(mo.battlen, FRACUNIT*10, 20)
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 200
							local baseangle = P_RandomRange(1, 360)*ANG1
							local dist = 180
							for i = 0, 24
								local angle = baseangle + i*6*ANG1
								local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)
								local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
								aura.state = S_AURA1
								aura.angle = angle - ANGLE_90
								aura.color = SKINCOLOR_MAGENTA
								aura.momz = P_RandomRange(2, 16)*FRACUNIT
								aura.scale = FRACUNIT*1
								aura.destscale = FRACUNIT*11
								P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
							end	
						end	
									
						if mo.deathtimer >= 20 and mo.deathtimer <= 220
							if not (mo.deathtimer%4)
								local ol = P_SpawnMobj(mo.x + P_RandomRange(-200, 200)*FRACUNIT, mo.y + P_RandomRange(-200, 200)*FRACUNIT, mo.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
								ol.sprite = SPR_THOK
								ol.color = SKINCOLOR_MAGENTA
								ol.scale = 1
								ol.destscale = FRACUNIT*10
								ol.scalespeed = FRACUNIT/5
								ol.frame = A|FF_FULLBRIGHT
								ol.tics = 20

								ol = P_SpawnMobj(mo.x + P_RandomRange(-200, 200)*FRACUNIT, mo.y + P_RandomRange(-200, 200)*FRACUNIT, mo.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
								ol.sprite = SPR_THOK
								ol.color = SKINCOLOR_MAGENTA
								ol.scale = 1
								ol.destscale = FRACUNIT*20
								ol.scalespeed = FRACUNIT
								ol.frame = A|FF_FULLBRIGHT|TR_TRANS50
								ol.tics = 8	
							end	
						end	
						
						if mo.deathtimer == 190
							mo.flags2 = $|MF2_DONTDRAW	
							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									P_FlashPal(p, 5, 20)
								end
							end
						end	

						if mo.deathtimer == 270
							mo.deathanim = nil
							return	-- deref
						end
					end,

}

attackDefs["tr_clawstrike"] = {
		name = "Claw Strike",
		type = ATK_SLASH,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		critical = 2,
		technical = COND_HEX,
		desc = "Heavy slash damage to all enemies.\nHeal for 5%. Critical heals more",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT			

			if timer == 1
				mo.totdam = 0
			end

			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end	
			
			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*36, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end	
			
			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z - FRACUNIT*36, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end				

			for i = 1,#hittargets
				local target = hittargets[i]
				if timer >= 20 and timer <= 40 and not (leveltime%2)
					local bs = P_SpawnMobj(target.x+(P_RandomRange(-212, 212)*FRACUNIT), target.y+(P_RandomRange(-212, 212)*FRACUNIT), target.z+(P_RandomRange(-1, 1)*FRACUNIT), MT_BUFU)
					bs.state = S_CDUST1
					bs.colorized = true
					bs.scale = FRACUNIT*10
					bs.color = SKINCOLOR_SILVER
					bs.momz = P_RandomRange(-1, 1)*FRACUNIT	
				end	
			end	
		
			if timer == 16
				playSound(mo.battlen, sfx_slash)
			end	
			
			if timer == 20
				playSound(mo.battlen, sfx_bexpld)
			end	

			for i = 1,#hittargets
				local target = hittargets[i]
				if timer == 20
					damageObject(target)
					mo.totdam = $1+target.damagetaken
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
				end	
			end

			if timer == 40 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal3)
				damageObject(mo, -(mo.totdam/4), DMG_NORMAL)
			elseif timer == 60 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
		critanim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT			

			if timer == 1
				mo.totdam = 0
			end

			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end	
			
			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*36, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end	
			
			if timer == 15
				local s = P_SpawnMobj(avgx, avgy, mo.z - FRACUNIT*36, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_BLACK
				s.scale = FRACUNIT*7
			end				

			for i = 1,#hittargets
				local target = hittargets[i]
				if timer >= 20 and timer <= 40 and not (leveltime%2)
					if not (timer%2)
						local ol = P_SpawnMobj(target.x + P_RandomRange(-220, 220)*FRACUNIT, target.y + P_RandomRange(-220, 220)*FRACUNIT, target.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
						ol.sprite = SPR_THOK
						ol.color = SKINCOLOR_SILVER
						ol.scale = 1
						ol.destscale = FRACUNIT*10
						ol.scalespeed = FRACUNIT/5
						ol.frame = A|FF_FULLBRIGHT
						ol.tics = 20

						ol = P_SpawnMobj(target.x + P_RandomRange(-220, 220)*FRACUNIT, target.y + P_RandomRange(-220, 220)*FRACUNIT, target.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
						ol.sprite = SPR_THOK
						ol.color = SKINCOLOR_SILVER
						ol.scale = 1
						ol.destscale = FRACUNIT*20
						ol.scalespeed = FRACUNIT
						ol.frame = A|FF_FULLBRIGHT|TR_TRANS50
						ol.tics = 8	
					end	
				end	
			end	
			
			if timer == 16
				playSound(mo.battlen, sfx_slash)
			end	
			
			if timer == 20
				playSound(mo.battlen, sfx_bexpld)
				playSound(mo.battlen, sfx_megi6)
			end	

			for i = 1,#hittargets
				local target = hittargets[i]
				if timer == 20
					damageObject(target)
					mo.totdam = $1+target.damagetaken
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
				end	
			end

			if timer == 40 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal4)
				damageObject(mo, -(mo.totdam/2), DMG_NORMAL)
			elseif timer == 60 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
}

attackDefs["tr_vel-da-doop"] = {
		name = "Vel-da-doop",
		type = ATK_ALMIGHTY,
		power = 300,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_SLEEP,
		statuschance = 20,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		cost = 30,
		desc = "Almighty Damage to all enemies.\nVery high odds of Sleep",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 10
				mo.dbs = {}
				playSound(mo.battlen, sfx_cboom)
				playSound(mo.battlen, sfx_bufu5)
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= TICRATE + TICRATE/2
			and mo.dbs

				for i = 1, 8
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_CDUST1
					s.color = SKINCOLOR_BLACK
					s.angle = P_RandomRange(0, 359)*ANG1
					s.scale = FRACUNIT*6
					s.scalespeed = FRACUNIT/6
					s.destscale = FRACUNIT*12
					s.dist = 0
					s.tics = 18
					mo.dbs[#mo.dbs+1] = s
				end
			end

			-- rotate the smoke
			if mo.dbs and #mo.dbs
				for i = 1, #mo.dbs do
					local s = mo.dbs[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*10
					s.dist = min(1024, $+32)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)

					if not P_RandomRange(0, 30)
						local t = P_SpawnMobj(s.x, s.y, s.z, MT_THOK)
						t.color = SKINCOLOR_BLACK
						t.frame = $|FF_FULLBRIGHT
						t.momz = P_RandomRange(4, 8)*FRACUNIT
						t.destscale = 1
						t.tics = TICRATE
					end
				end
			end

			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == TICRATE - TICRATE/4
					local dmg = max(1, target.hp/4)
					if target.boss
						dmg = nil
					end

					damageObject(target)
				end
			end

			if timer == TICRATE*2 - TICRATE/4 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["tr_volzello-anaia"] = {
	name = "Volzello-anaia",
	type = ATK_ALMIGHTY,
	power = 2200,
	accuracy = 550,
	costtype = CST_SP,
	cost = 160,
	critical = 3,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	target = TGT_ALLENEMIES,
	desc = "Vicious Almighty dmg to all enemies.",
	hudfunc = function(v, mo, timer)
		if timer >= 260 and timer < 270
			v.fadeScreen(0, (timer - 259))
		elseif timer >= 270 and timer < 300
			v.fadeScreen(0, 10)
		elseif timer >= 300 and timer < 310
			v.fadeScreen(0, (310 - timer))
		end
	end,
	
	anim = 	function(mo, targets, hittargets, timer)
		local cam = server.P_BattleStatus[mo.battlen].cam
		local impact = 265
		
		local avgx, avgy = 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT
		
		if timer == 1
			mo.orbs = {}
		elseif timer == 20 or timer == 37 or timer == 54
			if timer == 20
				playSound(mo.battlen, sfx_volza2)
				playSound(mo.battlen, sfx_darmat)
			end
			
			local ang = mo.angle
			local d = P_SpawnMobj(mo.x + 200*cos(ang), mo.y + 200*sin(ang), mo.z + 100*FRACUNIT, MT_THOK)
			
			d.sprite = SPR_VZAN
			d.frame = A|FF_FULLBRIGHT|TR_TRANS30
			d.scale = 1
			d.destscale = FRACUNIT*2
			d.scalespeed = (timer == 20 and FRACUNIT/32 or FRACUNIT/8)
			d.tics = impact - timer
			d.color = SKINCOLOR_BLACK
			d.tag = 1
			
			mo.orbs[#mo.orbs+1] = d
		elseif timer == 120 or timer == 137 or timer == 154
			if timer == 120
				playSound(mo.battlen, sfx_volza3)
				playSound(mo.battlen, sfx_megi4)
			end
			
			local ang = mo.angle
			local l = P_SpawnMobj(mo.x + 200*cos(ang), mo.y + 200*sin(ang), mo.z + 400*FRACUNIT, MT_THOK)
			
			l.sprite = SPR_NTHK
			l.frame = C|FF_FULLBRIGHT|TR_TRANS30
			l.scale = 1
			l.destscale = FRACUNIT*2
			l.scalespeed = (timer == 120 and FRACUNIT/32 or FRACUNIT/8)
			l.tics = impact - timer
			l.color = SKINCOLOR_WHITE
			l.tag = 4
			
			mo.orbs[#mo.orbs+1] = l
		elseif timer == 254
			localquake(mo.battlen, 10*FRACUNIT, TICRATE)
			playSound(mo.battlen, sfx_volza1)
			playSound(mo.battlen, sfx_debuff)
		elseif timer == 255 or timer == 260 or timer == 264
			local bang = P_SpawnMobj(mo.orbs[1].x, mo.orbs[1].y, mo.orbs[1].z + (mo.orbs[4].z - mo.orbs[1].z)/2, MT_THOK)
			bang.sprite = SPR_VZAN
			bang.frame = B|FF_FULLBRIGHT
			bang.blendmode = AST_SUBTRACT
			bang.color = SKINCOLOR_WHITE
			bang.scale = FRACUNIT/2
			bang.destscale = FRACUNIT*20
			bang.scalespeed = FRACUNIT
			bang.tics = 30
		elseif timer == 455
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 1, 10)
				end
			end

			for k,v in ipairs(mo.enemies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 1, 10)
				end
			end
		end
		
		if timer > 20 and timer < 100
			for i = 1, 2
				local focus = mo.orbs[1]
				local color = SKINCOLOR_BLACK
				local trail = P_SpawnMobj(focus.x + (400*cos(ANG1*P_RandomRange(1,359))),
										 focus.y + (400*sin(ANG1*P_RandomRange(1,359))),
										 focus.z + P_RandomRange(-200, 200)*FRACUNIT, MT_THOK)
				trail.color = color
				trail.sprite = SPR_VZAN
				trail.frame = A|FF_FULLBRIGHT|TR_TRANS10
				trail.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
				trail.tics = 26
				trail.scale = FRACUNIT/3
				trail.momx = (focus.x - trail.x)/25
				trail.momy = (focus.y - trail.y)/25
				trail.momz = ((focus.z + focus.height/2) - trail.z)/25
			end
		elseif timer >= 100 and timer < 120
			cam.z = $ + 10*FRACUNIT
		elseif timer > 120 and timer < 200
			for i = 1, 2
				local focus = mo.orbs[4]
				local color = SKINCOLOR_WHITE
				local trail = P_SpawnMobj(focus.x + (400*cos(ANG1*P_RandomRange(1,359))),
										 focus.y + (400*sin(ANG1*P_RandomRange(1,359))),
										 focus.z + P_RandomRange(-200, 200)*FRACUNIT, MT_THOK)
				trail.color = color
				trail.sprite = SPR_NTHK
				trail.frame = C|FF_FULLBRIGHT|TR_TRANS10
				trail.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
				trail.tics = 26
				trail.scale = FRACUNIT/3
				trail.momx = (focus.x - trail.x)/25
				trail.momy = (focus.y - trail.y)/25
				trail.momz = ((focus.z + focus.height/2) - trail.z)/25
			end
		elseif timer == 200
			playSound(mo.battlen, sfx_volza4)
			for i = 1, #mo.orbs
				if i >= 3
					mo.orbs[i].momz = -FRACUNIT/6
				else
					mo.orbs[i].momz = FRACUNIT/6
				end
			end
		elseif timer > 200 and timer < impact
			for i = 1, #mo.orbs
				local r = mo.orbs[i]
				if not r or not r.valid continue end
				
				r.momz = (15*$)/14
				
				local e = mo.orbs[i]
				local drip = P_SpawnMobj(e.x + P_RandomRange(-40,40)*FRACUNIT, e.y + P_RandomRange(-40,40)*FRACUNIT, e.z, MT_DUMMY)
				drip.tics = 8
				drip.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
				drip.destscale = 1
				drip.scalespeed = FRACUNIT/12
				if i < 4
					drip.sprite = SPR_VZAN
					drip.frame = A|FF_FULLBRIGHT|TR_TRANS30
					drip.momz = -P_RandomRange(18, 12)*FRACUNIT
					drip.color = SKINCOLOR_BLACK
				else
					drip.sprite = SPR_NTHK
					drip.frame = C|FF_FULLBRIGHT|TR_TRANS30
					drip.momz = P_RandomRange(18, 12)*FRACUNIT
					drip.color = SKINCOLOR_WHITE
				end
			end
		elseif timer >= impact and timer < impact+20
			cam.z = $ - 10*FRACUNIT
		elseif timer >= 270 and timer < 460
			localquake(mo.battlen, FRACUNIT*10, 2)
			local rad = (timer - 260)*2
			for i = 1, 10
				local trail = P_SpawnMobj(avgx + P_RandomRange(-rad, rad)*FRACUNIT,
										 avgy + P_RandomRange(-rad, rad)*FRACUNIT,
										 mo.z - 20*FRACUNIT, MT_THOK)
				trail.color = (P_RandomRange(0,10) and SKINCOLOR_WHITE or SKINCOLOR_BLACK)
				trail.sprite = SPR_VZAN
				trail.frame = A|FF_FULLBRIGHT|TR_TRANS10
				trail.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
				trail.tics = (timer > 430 and (460 - timer) or 30)
				trail.scale = 3*FRACUNIT/2
				trail.momz = 40*FRACUNIT
			end
			
			for i = 1, 4
				local thok = P_SpawnMobj(avgx+ (30+rad)*cos(P_RandomRange(1,356)*ANG1), avgy + (30+rad)*sin(P_RandomRange(1,356)*ANG1), mo.z, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS30
				thok.momz = P_RandomRange(40, 50)*FRACUNIT
				thok.color = SKINCOLOR_BLACK
				thok.tics = 30
				thok.scale = FRACUNIT*2
			end
		elseif timer == 460
			playSound(mo.battlen, sfx_eethit)
			for i = 1, #hittargets
				damageObject(hittargets[i])
			end
		elseif timer == 500
			mo.orbs = nil
			return true
		end
		
		if timer == 270
			playSound(mo.battlen, sfx_volza5)
			playSound(mo.battlen, sfx_volza6)
			playSound(mo.battlen, sfx_fortun)
		elseif timer == 455
			playSound(mo.battlen, sfx_megi6)
		end
		
		if mo.orbs and mo.orbs[2]
			for i = 1, #mo.orbs
				local s = mo.orbs[i]
				
				if s and s.valid and i ~= 1 and i ~= 4
					if s.scale >= s.destscale and s.destscale > FRACUNIT/4
						s.destscale = 1
					elseif s.scale <= FRACUNIT/4 and s.destscale <= FRACUNIT/4
						s.destscale = mo.orbs[s.tag].scale + FRACUNIT/4
					end
				end
			end
		end
	end,
}

attackDefs["tr_van-ku-oh"] = {
		name = "Van-ku-oh",
		type = ATK_ALMIGHTY,
		costtype = CST_SP,
		cost = 24,
		desc = "Severe Almighty damage to\nall enemies.",
		target = TGT_ALLENEMIES,
		critical = 2,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		accuracy = 100,
		power = 750,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT

			if timer == 10	
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*7
				m.frame = D
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				localquake(mo.battlen, FRACUNIT*30, 60)
				playSound(mo.battlen, sfx_s3k5e)
				playSound(mo.battlen, sfx_megi5)
				for j = 1, 32
					local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					st.state = S_MEGITHOK
					st.flags = $ & ~MF_NOGRAVITY
					st.momx = P_RandomRange(-128, 128)*FRACUNIT
					st.momy = P_RandomRange(-128, 128)*FRACUNIT
					st.momz = P_RandomRange(0, 128)*FRACUNIT
					st.fuse = TICRATE*4
					st.scale = FRACUNIT*3/5
				end				
			
			elseif timer == 15
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*7
				m.frame = C
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 20
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*7
				m.frame = B
				m.color = SKINCOLOR_WHITE
				m.tics = 5
				
			elseif timer == 25
				local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)				
				m.sprite = SPR_BEAM
				m.scale = FRACUNIT*10
				m.frame = A
				m.color = SKINCOLOR_WHITE
				m.tics = 5
			end

			if timer == 27
			or timer == 41
			or timer == 56
				playSound(mo.battlen, sfx_megi6)
				playSound(mo.battlen, sfx_prloop)
				local an = 0
				for i = 1, 32

					local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_GREY
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

					s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_GREY
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

					an = $ + (360/32)
				end
			end
			
			if timer == 31
			or timer == 46
			or timer == 61			
				playSound(mo.battlen, sfx_megi6)
				playSound(mo.battlen, sfx_prloop)
				local an = 0
				for i = 1, 32

					local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_SILVER
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

					s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_SILVER
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

					an = $ + (360/32)
				end	
			end	
			
			if timer == 36
			or timer == 51
			or timer == 66			
				playSound(mo.battlen, sfx_megi6)
				playSound(mo.battlen, sfx_prloop)
				local an = 0
				for i = 1, 32

					local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_BLACK
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

					s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
					s.color = SKINCOLOR_BLACK
					s.state = S_CDUST1
					s.scale = FRACUNIT*6
					s.fuse = TICRATE*3
					P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

					an = $ + (360/32)
				end			
			end
			
			if timer == 45
				playSound(mo.battlen, sfx_lydhit)
				for i = 1, #hittargets do
					damageObject(hittargets[i])
				end	

			elseif timer == 80
				return true
			end
		end,
}

attackDefs["tr_ark-zok-onkeim"] = {
		name = "Ark-zok-onkeim",
		type = ATK_ALMIGHTY,
		power = 1000,
		accuracy = 999,
		costtype = CST_SP,
		cost = 16,
		status = COND_FREEZE,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		statuschance = 100,
		desc = "Drains a Enemy's HP and\nInsta Freezes it",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
					local target = hittargets[1]

					if timer >= 20 and timer <= 40

						if timer == 20
							playSound(mo.battlen, sfx_endrn)
                        elseif timer == 30
                            damageObject(target, target.maxhp/10)
                            mo.buf_damage = target.damagetaken*5
                        end

						for i = 1,2
							local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
							thok.color = SKINCOLOR_PERIDOT
							thok.momx = P_RandomRange(-10, 10)*FRACUNIT
							thok.momy = P_RandomRange(-10, 10)*FRACUNIT
							thok.momz = P_RandomRange(-10, 10)*FRACUNIT
							thok.scale = FRACUNIT/10
							thok.destscale = FRACUNIT*2
						end

					elseif timer >= 50 and timer <= 70

						if timer == 60
						and target ~= mo
							mo.atk_attacker = mo
							playSound(mo.battlen, sfx_lsheal)
							damageObject(mo, -mo.buf_damage, DMG_NORMAL)
						end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_CYAN
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10

					elseif timer == 110
						return true
					end
				end,
}

attackDefs["tr_vilna-ya"] = {
		name = "Vilna-ya",
		type = ATK_ALMIGHTY,
		power = 850,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		desc = "Severe Almighty damage\n to all enemies.",
		target = TGT_ALLENEMIES,
		critical = 2,
		hudfunc = function(v, mo, timer)
			if timer > 40 and timer <= 60
				v.fadeScreen(0, min(10,(timer - 10)))
			elseif timer > 60 and timer < 80
				v.fadeScreen(0, max(0,10 - max(0,((timer - 60)/2))))
			end
		end,		
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets -- Get average position of targets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 10
				playSound(mo.battlen, sfx_hama3)
				playSound(mo.battlen, sfx_zio5)
				local firebol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
				firebol.scale = 1 
				firebol.tics = 40
				firebol.destscale = FRACUNIT*3 
				firebol.sprite = SPR_THOK
				firebol.color = SKINCOLOR_SILVER
				firebol.frame = A|FF_TRANS20
				firebol.scalespeed = (FRACUNIT*6)/80
			end
			
			if timer >= 10 and timer <= 40
				local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*256, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_WHITE
				orb.destscale = FRACUNIT*7
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
				
			if timer >= 60 and timer <= 90 and not (leveltime%5)
				for i = 1,10
					local ol = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*350, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_WHITE
					ol.scale = FRACUNIT*1
					ol.destscale = FRACUNIT*20
					ol.scalespeed = FRACUNIT*2
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer == 40
				playSound(mo.battlen, sfx_s3k54)
				playSound(mo.battlen, sfx_megi6)
				playSound(mo.battlen, sfx_frei1)
				localquake(mo.battlen, FRACUNIT*32, 30)
				playSound(mo.battlen, sfx_frei1)				
				playSound(mo.battlen, sfx_hamas2)
			end	

			if timer == 80
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
				end	
			end				

			if timer == 110
				return true
			end
		end,
}

attackDefs["tr_sol_eruption"] = {
		name = "Sol Eruption",
		type = ATK_ALMIGHTY,
		power = 750,
		accuracy = 90,
		critical = 1,
		target = TGT_ALLENEMIES,
		costtype = CST_SP,
		cost = 150,
		custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
			PDraw(v, x+3, y+3, v.cachePatch("LOST_ART"), V_SNAPTOLEFT)
			PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
		end,
		status = COND_BURN,
		statuschance = 5,		
		desc = "Lost Art.\nSevere Almighty Damage to all enemies.\nMay Burn.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		hudfunc2 = function(v, mo, timer)
			if timer >= 70 and timer < 150
				v.fadeScreen(32, 2)
			end
		end,
		
		hudfunc = function(v, mo, timer)
			local palnum = 0
			if timer >= 70 and timer < 140
				v.fadeScreen(palnum, min(10,(timer/2) - 35))
			elseif timer > 70 and timer <= 150
				v.fadeScreen(palnum, max(0,140 - timer))
			end
		end,
		anim = function(mo, targets, hittargets, timer)
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 1
				playSound(mo.battlen, sfx_debuff)
				playSound(mo.battlen, sfx_hama4)
				playSound(mo.battlen, sfx_firbol)
				local sol = P_SpawnMobj(avgx,avgy,mo.ceilingz - FRACUNIT*64,MT_DUMMY)
				sol.tics = -1
				sol.scale = 1
				sol.destscale = FRACUNIT*10
				sol.scalespeed = FRACUNIT*10
				sol.sprite = SPR_FLME
				sol.frame = I|FF_FULLBRIGHT
				sol.rollangle = ANGLE_180
				sol.momz = (sol.floorz - sol.z)/70
				
				mo.sol = sol
			elseif mo.sol
			and timer < 70
				A_BossScream(mo.sol,1)
				S_StartSound(mo.sol,sfx_s3kb4)
			end
			if timer == 70
				mo.sol.momz = 0
				playSound(mo.battlen, sfx_fortun)
				playSound(mo.battlen, sfx_megi4)
			end
			if timer >= 70 and timer < 140
				if not (leveltime%3)
					playSound(mo.battlen, sfx_s3k6e)
				end
				for i = 1, 14
					local boom = P_SpawnMobj(mo.sol.x + P_RandomRange(-32, 32)*mo.sol.scale, mo.sol.y + P_RandomRange(-32, 32)*mo.sol.scale, mo.sol.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3
				end
				localquake(mo.battlen, (mo.scale) * (timer - 70), 1)
			end
			if timer == 140
				playSound(mo.battlen, sfx_bkpoof)
				playSound(mo.battlen, sfx_bkpoof)
				playSound(mo.battlen, sfx_megi5)
				playSound(mo.battlen, sfx_tiexp)
				mo.sol.state = S_FBOMB_EXPL1
				DoExplosion(mo.sol)
			end
			
			if timer == 141
				for i = 1, #hittargets
					local target = hittargets[i]
					damageObject(target)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN 
						buffStat(target, "def", -25)
						buffStat(target, "agi", -25)
						BTL_logMessage(targets[1].battlen, "Agility down!\nDefense down!")
					end	
				end	
			end			
			
			if timer == 180
				mo.sol = nil
				return true
			end
		end,
}

attackDefs["tr_finaltrialmap"] = {
        name = "Loa's Map Loader",
        type = ATK_PASSIVE,
        desc = "Forces the map to change on the vision quest",
        passive = PSV_STARTBATTLE,
        anim = function(mo, targets, hittargets, timer)
            if G_BuildMapName() ~= "MAP45" //Nothing in () makes it check current map
                COM_BufInsertText(server, "map 45 -f") //Sends you to brazil... Maybe, literally?
            end //We didn't return true?!?! That's because PSV_STARTBATTLE only activates for ONE frame, and dont need no stinkn' returns
        end,
}

attackDefs["tr_statusnull"] = {
        name = "Status Null",
        type = ATK_PASSIVE,
        desc = "Nullify odds of being inflicted\non some status",
        passive = PSV_COND_RESIST,
        power = 100,
        status = COND_SHOCK|COND_BRAINWASH|COND_HEX|COND_SILENCE|COND_DESPAIR,
}