freeslot("sfx_lydeli", "sfx_stabl1", "sfx_stabl2", "sfx_cracom", "sfx_elilyd", 
"sfx_estpun", "sfx_estjos", "sfx_josest")


--Lloyd & Elie Star Blast

attackDefs["tr_starblast"] = {
	name = "Star Blast",
	type = ATK_ELEC,
	power = 200,
	accuracy = 100,
	costtype = CST_EP,
	cost = 1,
	target = TGT_ALLENEMIES,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}	


attackDefs["tr_starblast_2"] = {
	name = "Star Blast 2",
	type = ATK_ELEC,
	power = 600,
	accuracy = 100,
	costtype = CST_EP,
	cost = 2,
	target = TGT_ALLENEMIES,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}	


attackDefs["tr_starblast_3"] = {
	name = "Star Blast 3",
	type = ATK_ELEC,
	power = 1800,
	accuracy = 100,
	costtype = CST_EP,
	cost = 3,
	target = TGT_ALLENEMIES,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}


attackDefs["tr_starblast_c"] = {
	name = "Star Blast",
	type = ATK_ELEC,
	power = 200,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	target = TGT_ALLENEMIES,
	forcetp = true,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}	


attackDefs["tr_starblast_c2"] = {
	name = "Star Blast 2",
	type = ATK_ELEC,
	power = 600,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	target = TGT_ALLENEMIES,
	forcetp = true,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}	


attackDefs["tr_starblast_c3"] = {
	name = "Star Blast 3",
	type = ATK_ELEC,
	power = 1800,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	target = TGT_ALLENEMIES,
	forcetp = true,
	tr_castarea = 6,
	desc = "Lloyd and Elie's Combo Craft.\nLloyd barrages the enemies before Elie\nlaunches him at them in a ball of lightning (Area L).",
	anim_norepel = true,
	norandom = true,
	norogue = true,
	noenemycast = true,
	nometronome = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "lloyd" and mo.allies_noupdate[i].skin == "elie")	--we're Lloyd, is Elie with us?
				or (mo.skin == "elie" and mo.allies_noupdate[i].skin == "lloyd")	--we're Elie, is Lloyd with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "lloyd"
					BTL_logMessage(targets[1].battlen, "Elie is not in the active party.")
				elseif mo.skin == "elie"
					BTL_logMessage(targets[1].battlen, "Lloyd is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "lloyd")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "elie")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			if mo.skin == "lloyd"
				playSound(mo.battlen, sfx_lydeli)
			elseif mo.skin == "elie"
				playSound(mo.battlen, sfx_elilyd)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
			mo.rolls = {}
		end	
		
		if timer == 15 
			playSound(mo.battlen, sfx_stabl1)
		end	
		
		if timer == 15
		or timer == 40
		or timer == 50
			local s = P_SpawnMobj(avgx, avgy, mo.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_FLAME
			s.scale = FRACUNIT*4/2
			s.rollangle = P_RandomRange(0, 359)*ANG1
			mo.rolls[#mo.rolls+1] = s.rollangle

		elseif timer == 17
		or timer == 42
		or timer == 47
			local d = P_SpawnMobj(avgx, avgy, mo.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = A|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*4
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_FLAME

		elseif timer == 16
		or timer == 41
		or timer == 49
			for i=1,10
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_FLAME
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/22
				b.tics = 35
			end

			local s = P_SpawnMobj(avgx, avgy, mo.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*6
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_FLAME
		end	
		
		if timer == 60
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end	
		
		if timer == 80
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	
		
		if timer == 80
			playSound(mo.battlen, sfx_stabl2)
			playSound(mo.battlen, sfx_zio2)
			playSound(mo.battlen, sfx_s3k40)
		end	
			
		if timer >= 80 and timer <= 140
			localquake(mo.battlen, FRACUNIT*25, 10)
			local orb = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*20, MT_DUMMY)
			orb.sprite = SPR_DELK
			orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
			orb.scale = FRACUNIT*5
			orb.color = SKINCOLOR_LIME
			orb.destscale = FRACUNIT*22
			orb.scalespeed = FRACUNIT/4
			orb.tics = TICRATE/8
		end
			
		if timer >= 80 and timer <= 140
			local boom = P_SpawnMobj(avgx, avgy, mo.z,MT_DUMMY)
            boom.scale = FRACUNIT*5
			boom.sprite = SPR_MAGN
			boom.colorized = true
			boom.color = SKINCOLOR_LIME
			boom.frame = A|FF_TRANS70|FF_ANIMATE
			boom.tics = TICRATE/8
		end
			
		if timer == 80
			playSound(mo.battlen, sfx_pstop)
			localquake(mo.battlen, 7*FRACUNIT, 5)
			for i=1,16
				local b = P_SpawnMobj(avgx, avgy, mo.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*3
				b.destscale = FRACUNIT/22
			end
		end
		
		if timer >= 80 and timer <= 140
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PERIDOT
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*5
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 120
		or timer == 130
		or timer == 140
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 141
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end

		elseif timer == 160
			mo.rolls = nil
			return true
		end
	end,
}	


--Estelle & Joshua Timeless Pummel

attackDefs["tr_timelesspummel"] = {
	name = "Timeless Pummel",
	type = ATK_BLESS,
	power = 200,
	accuracy = 100,
	costtype = CST_EP,
	cost = 1,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}


attackDefs["tr_timelesspummel_2"] = {
	name = "True Timeless Pummel",
	type = ATK_BLESS,
	power = 600,
	accuracy = 100,
	costtype = CST_EP,
	cost = 2,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}


attackDefs["tr_timelesspummel_3"] = {
	name = "Supreme Timeless Pummel",
	type = ATK_BLESS,
	power = 1800,
	accuracy = 100,
	costtype = CST_EP,
	cost = 3,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			mo.tr_ccpartner = false
			local is_alive = false
			--local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				--can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						--if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
						--	can_afford = true
							break	--Emerald Power version
						--end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			--elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
			--	BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
			--	return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}



attackDefs["tr_timelesspummel_c"] = {
	name = "Timeless Pummel",
	type = ATK_BLESS,
	power = 200,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	forcetp = true,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}


attackDefs["tr_timelesspummel_c2"] = {
	name = "True Timeless Pummel",
	type = ATK_BLESS,
	power = 600,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	forcetp = true,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}


attackDefs["tr_timelesspummel_c3"] = {
	name = "Supreme Timeless Pummel",
	type = ATK_BLESS,
	power = 1800,
	accuracy = 100,
	costtype = CST_SP,
	cost = 100,
	forcetp = true,
	target = TGT_ALLENEMIES,
	desc = "Estelle and Joshua's Combo Craft.\nJoshua and Estelle overwhelm the enemy \nbefore finishing with a large blast.",
	anim_norepel = true,
	norandom = true,
	nometronome = true,
	norogue = true,
	noenemycast = true,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT3"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	nocast = function(targets, n, mo) --the part that makes it a Team attack
			
			mo.tr_ccpartner = false
			local is_alive = false
			local can_afford = false
			
			for i = 1, #mo.allies_noupdate do	--find our partner
				is_alive = false
				can_afford = false
				if (mo.skin == "estelle" and mo.allies_noupdate[i].skin == "joshua")	--we're Estelle, is Joshua with us?
				or (mo.skin == "joshua" and mo.allies_noupdate[i].skin == "estelle")	--we're Joshua, is Estelle with us?
					mo.tr_ccpartner = mo.allies_noupdate[i]
					if mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0	--is our partner alive?
						is_alive = true
						if mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100	--can out partner afford this as well?
							can_afford = true
							break
						end
					end
				end
			end
						
			if not mo.tr_ccpartner or mo.tr_ccpartner == false
		  
				if mo.skin == "estelle"
					BTL_logMessage(targets[1].battlen, "Joshua is not in the active party.")
				elseif mo.skin == "joshua"
					BTL_logMessage(targets[1].battlen, "Estelle is not in the active party.")
				else
					BTL_logMessage(targets[1].battlen, "You don't know this Combo Craft!")	--who the fuck are you?!
				end
				return true  -- if we couldn't find our friend, return true
			elseif not is_alive or is_alive == false or not (mo.tr_ccpartner.hp and mo.tr_ccpartner.hp > 0)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." is unconscious!")
				return true  -- We found our friend, but they're not very alive right now.
			elseif not can_afford or can_afford == false or not (mo.tr_ccpartner.tp and mo.tr_ccpartner.tp >= 100)
			
				BTL_logMessage(targets[1].battlen, mo.tr_ccpartner.name.." doesn't have enough Craft Points.")
				return true  -- Our friend is alive, but can't afford to use this move with us.
			end
    end,
	hudfunc = function(v, mo, timer)
			for i = 1, #mo.allies do
				--local target = mo.allies[i]

				local firstt = TICRATE - timer
				local t = (TICRATE - (firstt*2))
				local t2 = (t<<FRACBITS) /3
				local t3 = t2

				-- circles, or something!
				local scale = t*FRACUNIT/6
				local trflag = V_70TRANS
				if firstt < 15
					trflag = V_90TRANS - (V_10TRANS)
				end
				if scale > 0	-- lol negative scales
				and timer < TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_B"), trflag)
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, scale, v.cachePatch("H_1M_C"))
				end

				t3 = FixedMul(t3, t3)
				t3 = $+ FixedMul(t3, t2)

				
				
				-- draw chars:
				local pp = v.cachePatch(charStats[mo.skin] and charStats[mo.skin].hudaoa or "estelle")
				if mo.status_condition == COND_SUPER
				and charStats[mo.skin] and charStats[mo.skin].hudsaoa
					pp = v.cachePatch(charStats[mo.skin].hudsaoa)	-- super players
				end
				if timer <100
					v.drawScaled((150)<<FRACBITS + t3/3, (80)<<FRACBITS +t3/8, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.color))
					pp = v.cachePatch(charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudaoa or "joshua")
					if mo.tr_ccpartner.status_condition == COND_SUPER
					and charStats[mo.tr_ccpartner.skin] and charStats[mo.tr_ccpartner.skin].hudsaoa
						pp = v.cachePatch(charStats[mo.tr_ccpartner.skin].hudsaoa)	-- super players
					end
					v.drawScaled((150)<<FRACBITS - t3/3, (80)<<FRACBITS -t3/7, FRACUNIT/2, pp, V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, mo.tr_ccpartner.color))
					--v.drawScaled((120)<<FRACBITS -t3/3, (70)<<FRACBITS +t3/8, FRACUNIT/2, v.cachePatch("H_FPASSLAME1"), V_SNAPTOLEFT)
					--v.drawScaled((113)<<FRACBITS +t3/3, (83)<<FRACBITS -t3/7, FRACUNIT/2, v.cachePatch("H_FPASSLAME2"), V_SNAPTOLEFT)
				end
			end
		end,
	anim = function(mo, targets, hittargets, timer)	
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		
		if timer == 1
			if mo.skin == "estelle"
				playSound(mo.battlen, sfx_estjos)
			elseif mo.skin == "joshua"
				playSound(mo.battlen, sfx_josest)
			end
			if charStats[mo.tr_ccpartner.stats].tpbar	--partner cost
			and charStats[mo.tr_ccpartner.stats].tpspuse
				mo.tr_ccpartner.tp = max(0, $-100)
			else
				mo.tr_ccpartner.sp = max(0, $-100)
			end
		end	

		if timer == 10
			playSound(mo.battlen, sfx_flickr)
		end	
		
		if timer >= 10
		and timer <= 40
			if leveltime%5 == 0
				local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*2
				d.scale = FRACUNIT*2
				d.destscale = FRACUNIT*7
				d.scalespeed = FRACUNIT/4
			end
		end
			
		if timer == 30
			for i = 1, #hittargets
				local target = hittargets[i]
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
			end	
		end
		
		if timer == 40
			playSound(mo.battlen, sfx_estpun)
		end	
		
		if timer >= 40
		and timer <= 80
		and leveltime%5 == 0
			local x = avgx + P_RandomRange(-40, 40)*FRACUNIT
			local y = avgy + P_RandomRange(-40, 40)*FRACUNIT
			local z = mo.z + P_RandomRange(0, 30)*FRACUNIT
			for i=1,16
				local b = P_SpawnMobj(x, y, z+2*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-3, 3)*FRACUNIT
				b.momy = P_RandomRange(-3, 3)*FRACUNIT
				b.momz = P_RandomRange(4, 16)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
			for i=1,16
				local b = P_SpawnMobj(x, y, z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-8, 8)*FRACUNIT
				b.momy = P_RandomRange(-8, 8)*FRACUNIT
				b.momz = P_RandomRange(-8, 8)*FRACUNIT
				b.state = S_AOADUST1
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT*6
				b.destscale = FRACUNIT/12
			end
		end
		
		if timer == 90
			local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*50, MT_DUMMY)
			s.color = SKINCOLOR_WHITE
			s.state = S_MEGISTAR1
			s.scale = FRACUNIT*7
			playSound(mo.battlen, sfx_cracom)
		end
		
		if timer == 110
			for i = 1, #hittargets
				local target = hittargets[i]
				DoExplosion(target)
			end
		end	
		
		if timer == 110
			localquake(mo.battlen, FRACUNIT*20, 10)
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 5, 5)
				end
			end
		end	

		if timer >= 110
		and timer < 150
			for i = 1, 12
				local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*5/2
			end
			if timer%4 == 0
				playSound(mo.battlen, sfx_fire1)
			end

			if timer == 140
				for i = 1, 32
					local smoke = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(avgx, avgy, mo.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
			end
		end
		
		if timer >= 110 and timer <= 150
			for i = 1, 2
				local m = P_SpawnMobj(avgx + P_RandomRange(-64, 64)*FRACUNIT, avgy  + P_RandomRange(-64, 64)*FRACUNIT, mo.z, MT_DUMMY)
				m.tics = -1
				m.color = SKINCOLOR_PEACHY
				m.frame = FF_FULLBRIGHT
				m.scale = FRACUNIT*3
				m.momz = FRACUNIT*64
				m.fuse = TICRATE
				m.sprite = SPR_THOK
			end	
		end
		
		if timer == 130
		or timer == 140
		or timer == 150
            playSound(mo.battlen, sfx_megi5)
            for j = 1, 32
                local st = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
                st.state = S_MEGITHOK
                st.flags = $ & ~MF_NOGRAVITY
                st.momx = P_RandomRange(-128, 128)*FRACUNIT
                st.momy = P_RandomRange(-128, 128)*FRACUNIT
                st.momz = P_RandomRange(0, 128)*FRACUNIT
                st.fuse = TICRATE*4
                st.scale = FRACUNIT*2/3
            end
		end
		
		if timer == 151
			playSound(mo.battlen, sfx_lydhit)
			for i = 1, #hittargets
				local target = hittargets[i]
				damageObject(target)
			end
			
		elseif timer == 175
			return true
		end
	end,
}




