BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Special Support Section",
  description = {"Test your strength", "against Lloyd and Elie"},
  level = 85,
  music = "BARIR2",
  time = TICRATE*60*32,
  items = {{"tr_tear-allbalm", 30}, {"tr_spcharge2", 15}, {"tr_spcharge3", 10}, {"tr_curiabalm", 15}, {"tr_recuriabalm", 10}, {"tr_revbalm", 10}, {"tr_celbalm", 7}, {"hypercombiring", 15}, {"dekaja gem", 30}, {"soma", 3}},
  waves = {
			{"enemylloyd2", "enemyelie2"},
		},
}

BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Wind from Liberl",
  description = {"Test your strength", "against Estelle, Joshua and Tita"},
  level = 85,
  music = "SOFHT",
  time = TICRATE*60*32,
  items = {{"tr_tear-allbalm", 30}, {"tr_spcharge2", 25}, {"tr_spcharge3", 15}, {"tr_curiabalm", 20}, {"tr_recuriabalm", 15}, {"tr_revbalm", 15}, {"tr_celbalm", 15}, {"hypercombiring", 15}, {"tr_stablet", 20}, {"dekaja gem", 30}, {"soma", 3}},
  waves = {
			{"enemyestelle2", "enemyjoshua2", "enemytita2"},
		},
}

BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Trails Group",
  description = {"Battle against everyone", "in the Trails pack!"},
  level = 85,
  music = "SETHR",
  time = TICRATE*60*40,
  items = {{"tr_tear-allbalm", 40}, {"tr_spcharge3", 35}, {"tr_curiabalm", 30}, {"tr_recuriabalm", 25}, {"tr_revbalm", 30}, {"tr_celbalm", 20}, {"hypercombiring", 20}, {"dekaja gem", 40}, {"tr_stablet", 40}, {"soma", 5}},
  waves = {
			{"enemylloyd", "enemyestelle", "enemyjoshua", "enemytita", "enemyelie"},
		},
}

enemyList["enemylloyd"] = {
		name = "Lloyd",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "lloydskillset",
		melee_natk = "tr_tonfas_m",	-- normal melee attack
		--melee_satk = "risingsun", //Let's gooooooooooooo
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 3025,
		sp = 3630,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_tigercharge_c", 1, 1}, {"tr_risingsun_c", 32, 2}, {"tr_tigercharge_c2", 60, 1}, {"tr_risingsun_c2", 72, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"elie", "tr_starblast_c", 25}, {"elie", "tr_starblast_c2", 50}, {"elie", "tr_starblast_c3", 75},
			}
			or {
				{"elie", "tr_starblast", 25}, {"elie", "tr_starblast_2", 50}, {"elie", "tr_starblast_3", 75},
		},
		
		strength = 60,
		magic = 40,
		endurance = 40,
		agility = 40,
		luck = 50,
		boss = true,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 33300,
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,

		skin = "lloyd",			-- for "player" fights.
		color = SKINCOLOR_CERULEAN,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, B, C, D, E, F, G, 4, "SPR2_MLEL"},	-- attack
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_DASH"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		anim_special5 =		{SPR_PLAY, A, 35, "SPR2_MLEE"},
		anim_special6 =		{SPR_PLAY, B, 35, "SPR2_TAL0"}, //Burning Heart
		anim_special7 =		{SPR_PLAY, C, 35, "SPR2_TAL0"},
		anim_special8 =		{SPR_PLAY, A, B, C, D, E, F, G, 2, "SPR2_MLEL"},	-- beat down
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		aoa_quote = "Let's overcome this \nbarrier together!",
		
		skills = {
					"tr_petrify_cloud", "tr_crimson_ray", "tr_tearal",
					tpBar and "tr_extend_hearts_c" or "tr_extend_hearts", tpBar and "tr_zero_breaker_c" or "tr_zero_breaker_c",
					tpBar and "tr_burning_heart_c2" or "tr_burning_heart_2", tpBar and "tr_brave_smash_c3" or "tr_brave_smash_3",
					tpBar and "tr_stun_break_c3" or "tr_stun_break_3", "tr_arcus_counter"
				}
	}
	
enemyList["enemyestelle"] = {
		name = "Estelle",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "estelleskillset",
		melee_natk = "tr_staff_hit",
		--melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,

		atk = 33,
		acc = 90,
		crit = 2,
		
		hp = 3270,
		sp = 3320,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_pummel_c", 1, 1}, {"tr_barrage_c", 15, 2}, {"tr_pummel_c2", 30, 1}, {"tr_barrage_c2", 45, 2}, {"tr_twheeloftime_c", 70, 1}, {"tr_twheeloftime_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"joshua", "tr_timelesspummel_c", 25}, {"joshua", "tr_timelesspummel_c2", 50}, {"joshua", "tr_timelesspummel_c3", 75},
			}
			or {
				{"joshua", "tr_timelesspummel", 25}, {"joshua", "tr_timelesspummel_2", 50}, {"joshua", "tr_timelesspummel_3", 75},
		},
		
		strength = 45,
		magic = 50,
		endurance = 60,
		agility = 60,
		luck = 40,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 43300,
		weak = ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,

		skin = "estelle",			-- for "player" fights.
		color = SKINCOLOR_ORANGE,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 = 	{SPR_PLAY, A, 2, "SPR2_MLEE"}, -- hammer prep
		anim_special2 = 	{SPR_PLAY, B, C, D, E, 2, "SPR2_MLEE"}, -- hammer swing
		anim_special3 = 	{SPR_PLAY, A, "SPR2_MLEE"},	-- hammer swung
		anim_special5 = 	{SPR_PLAY, A, B, C, D, E, 3, "SPR2_TAL1"},	-- Pummel/Barrage Forward Walk
		anim_special6 = 	{SPR_PLAY, E, A, A, A, A, 3, "SPR2_TAL1"},	-- Barrage Forward Jump
		anim_special7 = 	{SPR_PLAY, A, B, C, D, 3, "SPR2_MLEL"},	-- Pummel/Barrage Staff Jab
		anim_special8 = 	{SPR_PLAY, A, A, B, B, C, C, D, D, E, E, F, G, G, H, H, H, 2, "SPR2_TAL2"},	-- Barrage Kick Jump (28)| A-C kick (12) , D impact (4), E-H land (12), jab. Ghost Trail.
		anim_special9 = 	{SPR_PLAY, I, J, K, K, B, B, A, A, F, F, F, F, 2, "SPR2_TAL2"},	-- Barrage Kick-Flip (28)| I-K rising kick (8), B-A flip (8), F land (4), stand.
		--Estelle does a twirl-strike here in Barrage animation. Run anim_special2 while rotating her -36' per tick (clock-wise).
		anim_special10 = 	{SPR_PLAY, O, P, Q, R, S, T, U, U, U, U, U, U, U, U, U, 2, "SPR2_TAL2"},	-- Barrage Rising Strike (14)
		anim_special11 = 	{SPR_PLAY, A, B, B, B, B, B, B, B, B, B, B, B, B, B, B, B, C, D, E, F, G, G, G, G, G, G, G, G, G, G, G, G, G, G, 2, "SPR2_TAL3"},	-- Barrage Grand Finale (42)
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_xhurt = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		aoa_quote = "Alright guys!Time for \nsome ul-tra-vio-lence!",
		
		skills =	{
						tpBar and "tr_hurricane_c3" or "tr_hurricane_3", tpBar and "tr_morale_c" or "tr_morale", "tr_athelas",
						"tr_cocytus", "tr_maelstorm", "tr_la_tearal", "tr_tear-all", "tr_la_curia", "tr_arcus_counter"
					}
	}

enemyList["enemyjoshua"] = {
		name = "Joshua",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "joshuaskillset",
		melee_natk = "tr_slash_strike", 
		--melee_satk = "phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJOSH1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 3295,
		sp = 3660,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_sever_c", 1, 1},  {"tr_blackfang_c", 15, 2}, {"tr_sever_c2", 30, 1}, {"tr_blackfang_c2", 45, 2}, {"tr_phantomraid_c", 60, 2}, {"tr_phantomraid_c2", 90, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"estelle", "tr_timelesspummel_c", 25}, {"estelle", "tr_timelesspummel_c2", 50}, {"estelle", "tr_timelesspummel_c3", 75},
			}
			or {
				{"estelle", "tr_timelesspummel", 25}, {"estelle", "tr_timelesspummel_2", 50}, {"estelle", "tr_timelesspummel_3", 75},
		},
		
		
		strength = 40,
		magic = 40,
		endurance = 60,
		agility = 50,
		luck = 30,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,

		skin = "joshua",			-- for "player" fights.
		color = SKINCOLOR_JET,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_SPIN"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, F, E, D, C, B, A, 2, "SPR2_SPIN"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_TAL0"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		--anim_special4 =		{SPR_PLAY, A, B, C, C, C, D, 4, "SPR2_TAL1"},	--Sever, flashes daggers before jumping
		--anim_special5 =		{SPR_PLAY, E, F, 4, "SPR2_TAL1"},	--Sever, first two strikes
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",
		
		skills =	{
						tpBar and "tr_scloak_dagger_c" or "tr_scloak_dagger", "tr_chrono_break", "tr_chrono_drive",
						tpBar and "tr_lightning_flash_c" or "tr_lightning_flash", tpBar and "tr_twinshadfang_c" or "tr_twinshadfang",
						"tr_phantom_phobia", "tr_abyss_fall", "tr_death_scream", "tr_arcus_counter"
					}
}	

enemyList["enemytita"] = {
		name = "Tita",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "titaskillset",
		melee_natk = "tr_explosion",
		--melee_satk = "satbeam",
		
		supercolor_start = SKINCOLOR_SUPERTITA1,

		atk = 46,
		acc = 85,
		crit = 1,
		
		hp = 3198,
		sp = 3427,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_cannon_impulse_c", 1, 1}, {"tr_cannon_impulse_c2", 30, 1}, {"tr_satbeam_c", 60, 2}, {"tr_cannon_impulse_cf", 75, 1}, {"tr_satbeam_c2", 90, 2},
		},
		
		strength = 40,
		magic = 40,
		endurance = 50,
		agility = 40,
		luck = 30,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,

		skin = "tita",			-- for "player" fights.
		color = SKINCOLOR_RED,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TAL1"}, //108 Frames, a note for da stoopid Zoraxua
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_ROLL"},	
		anim_special3 =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, L, L, L, M, M, M, M, M, M, M, M, M, M, M, M, 4, "SPR2_TAL2"}, --gun comes out, fires. (64+ frames)
		anim_special4 =		{SPR_PLAY, N, 4, "SPR2_TAL2"},	--gun side-view
		anim_special5 =		{SPR_PLAY, O, 4, "SPR2_TAL2"},	--gun diagonal-view
		anim_special6 =		{SPR_PLAY, M, M, M, L, K, J, I, H, H, H, H, H, 4, "SPR2_TAL2"},	--gun stops (32+ frames)
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, //?
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel1"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4", "sfx_tiaoa5"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",
		
		skills =	{
						tpBar and "tr_vital cannon_c3" or "tr_vital cannon_3", tpBar and "tr_smokecannon_c2" or "tr_smokecannon_2",
						"tr_impassion", "tr_dark matter EX", "nuke amp", "tr_fortuna", "tr_altair cannon", "tr_crescent mirror", "tr_arcus_counter"
					}
}

enemyList["enemyelie"] = {
		name = "Elie",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "elieskillset",
		melee_natk = "tr_revolver",	
		--melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 3496,
		sp = 3480,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_aerialcannon_c", 30, 2}, {"tr_aerialcannon_c2", 60, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"lloyd", "tr_starblast_c", 25}, {"lloyd", "tr_starblast_c2", 50}, {"lloyd", "tr_starblast_c3", 75},
			}
			or {
				{"lloyd", "tr_starblast", 25}, {"lloyd", "tr_starblast_2", 50}, {"lloyd", "tr_starblast_3", 75},
		},
		
		strength = 50,
		magic = 50,
		endurance = 45,
		agility = 48,
		luck = 30,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,

		skin = "elie",			-- for "player" fights.
		color = SKINCOLOR_RASPBERRY,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_MLEE"},
		anim_special2 =		{SPR_PLAY, A, B, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, 2, "SPR2_MLEL"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3"},
		vfx_levelup = {"sfx_elkil2"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",
		
		skills =	{
						tpBar and "tr_triple_piercer_c" or "tr_triple_piercer", "elec amp", "wind amp",
						"tr_innocence_arc", "tr_grand_stream", "tr_sylpharion", "tr_zodiac", "tr_ragna_blast", "tr_arcus_counter"
					}
}

enemyList["enemylloyd2"] = {
		name = "Lloyd",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "lloydskillset",
		melee_natk = "tr_tonfas_m",	-- normal melee attack
		--melee_satk = "risingsun", //Let's gooooooooooooo
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 5175,
		sp = 5300,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_tigercharge_c", 1, 1}, {"tr_risingsun_c", 32, 2}, {"tr_tigercharge_c2", 60, 1}, {"tr_risingsun_c2", 72, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"elie", "tr_starblast_c", 25}, {"elie", "tr_starblast_c2", 50}, {"elie", "tr_starblast_c3", 75},
			}
			or {
				{"elie", "tr_starblast", 25}, {"elie", "tr_starblast_2", 50}, {"elie", "tr_starblast_3", 75},
		},
		
		strength = 50,
		magic = 40,
		endurance = 40,
		agility = 40,
		luck = 45,
		boss = true,
        thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 33300,
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,

		skin = "lloyd",			-- for "player" fights.
		color = SKINCOLOR_CERULEAN,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, B, C, D, E, F, G, 4, "SPR2_MLEL"},	-- attack
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_DASH"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		anim_special5 =		{SPR_PLAY, A, 35, "SPR2_MLEE"},
		anim_special6 =		{SPR_PLAY, B, 35, "SPR2_TAL0"}, //Burning Heart
		anim_special7 =		{SPR_PLAY, C, 35, "SPR2_TAL0"},
		anim_special8 =		{SPR_PLAY, A, B, C, D, E, F, G, 2, "SPR2_MLEL"},	-- beat down
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		aoa_quote = "Let's overcome this \nbarrier together!",
		
		skills = {
					"tr_petrify_cloud", "tr_crimson_ray", "tr_tearal",
					tpBar and "tr_extend_hearts_c" or "tr_extend_hearts", tpBar and "tr_zero_breaker_c" or "tr_zero_breaker_c",
					tpBar and "tr_burning_heart_c2" or "tr_burning_heart_2", tpBar and "tr_brave_smash_c3" or "tr_brave_smash_3",
					tpBar and "tr_stun_break_c3" or "tr_stun_break_3", "tr_arcus_counter"
				}
	}
	
enemyList["enemyestelle2"] = {
		name = "Estelle",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "estelleskillset",
		melee_natk = "tr_staff_hit",
		--melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,

		atk = 33,
		acc = 90,
		crit = 2,
		
		hp = 4810,
		sp = 6320,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_pummel_c", 1, 1}, {"tr_barrage_c", 15, 2}, {"tr_pummel_c2", 30, 1}, {"tr_barrage_c2", 45, 2}, {"tr_twheeloftime_c", 70, 1}, {"tr_twheeloftime_c2", 90, 1},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"joshua", "tr_timelesspummel_c", 25}, {"joshua", "tr_timelesspummel_c2", 50}, {"joshua", "tr_timelesspummel_c3", 75},
			}
			or {
				{"joshua", "tr_timelesspummel", 25}, {"joshua", "tr_timelesspummel_2", 50}, {"joshua", "tr_timelesspummel_3", 75},
		},
		
		strength = 40,
		magic = 60,
		endurance = 45,
		agility = 50,
		luck = 30,
		boss = true,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,

		skin = "estelle",			-- for "player" fights.
		color = SKINCOLOR_ORANGE,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 = 	{SPR_PLAY, A, 2, "SPR2_MLEE"}, -- hammer prep
		anim_special2 = 	{SPR_PLAY, B, C, D, E, 2, "SPR2_MLEE"}, -- hammer swing
		anim_special3 = 	{SPR_PLAY, A, "SPR2_MLEE"},	-- hammer swung
		anim_special5 = 	{SPR_PLAY, A, B, C, D, E, 3, "SPR2_TAL1"},	-- Pummel/Barrage Forward Walk
		anim_special6 = 	{SPR_PLAY, E, A, A, A, A, 3, "SPR2_TAL1"},	-- Barrage Forward Jump
		anim_special7 = 	{SPR_PLAY, A, B, C, D, 3, "SPR2_MLEL"},	-- Pummel/Barrage Staff Jab
		anim_special8 = 	{SPR_PLAY, A, A, B, B, C, C, D, D, E, E, F, G, G, H, H, H, 2, "SPR2_TAL2"},	-- Barrage Kick Jump (28)| A-C kick (12) , D impact (4), E-H land (12), jab. Ghost Trail.
		anim_special9 = 	{SPR_PLAY, I, J, K, K, B, B, A, A, F, F, F, F, 2, "SPR2_TAL2"},	-- Barrage Kick-Flip (28)| I-K rising kick (8), B-A flip (8), F land (4), stand.
		--Estelle does a twirl-strike here in Barrage animation. Run anim_special2 while rotating her -36' per tick (clock-wise).
		anim_special10 = 	{SPR_PLAY, O, P, Q, R, S, T, U, U, U, U, U, U, U, U, U, 2, "SPR2_TAL2"},	-- Barrage Rising Strike (14)
		anim_special11 = 	{SPR_PLAY, A, B, B, B, B, B, B, B, B, B, B, B, B, B, B, B, C, D, E, F, G, G, G, G, G, G, G, G, G, G, G, G, G, G, 2, "SPR2_TAL3"},	-- Barrage Grand Finale (42)
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_xhurt = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		aoa_quote = "Alright guys!Time for \nsome ul-tra-vio-lence!",
		
		skills =	{
						tpBar and "tr_hurricane_c3" or "tr_hurricane_3", tpBar and "tr_morale_c" or "tr_morale", "tr_athelas",
						"tr_cocytus", "tr_maelstorm", "tr_la_tearal", "tr_tear-all", "tr_la_curia", "tr_arcus_counter"
					}
	}

enemyList["enemyjoshua2"] = {
		name = "Joshua",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "joshuaskillset",
		melee_natk = "tr_slash_strike", 
		--melee_satk = "phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJOSH1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 3885,
		sp = 5260,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_sever_c", 1, 1},  {"tr_blackfang_c", 15, 2}, {"tr_sever_c2", 30, 1}, {"tr_blackfang_c2", 45, 2}, {"tr_phantomraid_c", 60, 2}, {"tr_phantomraid_c2", 90, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"estelle", "tr_timelesspummel_c", 25}, {"estelle", "tr_timelesspummel_c2", 50}, {"estelle", "tr_timelesspummel_c3", 75},
			}
			or {
				{"estelle", "tr_timelesspummel", 25}, {"estelle", "tr_timelesspummel_2", 50}, {"estelle", "tr_timelesspummel_3", 75},
		},
		
		
		strength = 48,
		magic = 40,
		endurance = 55,
		agility = 60,
		luck = 30,
		boss = true,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,

		skin = "joshua",			-- for "player" fights.
		color = SKINCOLOR_JET,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_SPIN"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, F, E, D, C, B, A, 2, "SPR2_SPIN"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_TAL0"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		--anim_special4 =		{SPR_PLAY, A, B, C, C, C, D, 4, "SPR2_TAL1"},	--Sever, flashes daggers before jumping
		--anim_special5 =		{SPR_PLAY, E, F, 4, "SPR2_TAL1"},	--Sever, first two strikes
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",
		
		skills =	{
						tpBar and "tr_scloak_dagger_c" or "tr_scloak_dagger", "tr_chrono_break", "tr_chrono_drive",
						tpBar and "tr_lightning_flash_c" or "tr_lightning_flash", tpBar and "tr_twinshadfang_c" or "tr_twinshadfang",
						"tr_phantom_phobia", "tr_abyss_fall", "tr_death_scream", "tr_arcus_counter"
					}
}

enemyList["enemytita2"] = {
		name = "Tita",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "titaskillset",
		melee_natk = "tr_explosion",
		--melee_satk = "satbeam",
		
		supercolor_start = SKINCOLOR_SUPERTITA1,

		atk = 46,
		acc = 85,
		crit = 1,
		
		hp = 4258,
		sp = 5007,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_cannon_impulse_c", 1, 1}, {"tr_cannon_impulse_c2", 30, 1}, {"tr_satbeam_c", 60, 2}, {"tr_cannon_impulse_cf", 75, 1}, {"tr_satbeam_c2", 90, 2},
		},
		
		strength = 40,
		magic = 50,
		endurance = 60,
		agility = 40	,
		luck = 30,
		boss = true,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 300,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,

		skin = "tita",			-- for "player" fights.
		color = SKINCOLOR_RED,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TAL1"}, //108 Frames, a note for da stoopid Zoraxua
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_ROLL"},	
		anim_special3 =		{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, K, L, L, L, L, M, M, M, M, M, M, M, M, M, M, M, M, 4, "SPR2_TAL2"}, --gun comes out, fires. (64+ frames)
		anim_special4 =		{SPR_PLAY, N, 4, "SPR2_TAL2"},	--gun side-view
		anim_special5 =		{SPR_PLAY, O, 4, "SPR2_TAL2"},	--gun diagonal-view
		anim_special6 =		{SPR_PLAY, M, M, M, L, K, J, I, H, H, H, H, H, 4, "SPR2_TAL2"},	--gun stops (32+ frames)
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, //?
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel1"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4", "sfx_tiaoa5"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",
		
		skills =	{
						tpBar and "tr_vital cannon_c3" or "tr_vital cannon_3", tpBar and "tr_smokecannon_c2" or "tr_smokecannon_2",
						"tr_impassion", "tr_dark matter EX", "nuke amp", "tr_fortuna", "tr_altair cannon", "tr_crescent mirror", "tr_arcus_counter"
					}
}

enemyList["enemyelie2"] = {
		name = "Elie",
		skillchance = 90,	-- /100, probability of using a skill
		level = 85,
		persona = "elieskillset",
		melee_natk = "tr_revolver",	
		--melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 5149,
		sp = 5480,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_aerialcannon_c", 30, 2}, {"tr_aerialcannon_c2", 60, 2},
		},
		c_craft = C2SBarEdits and {		--This character uses Combo Crafts. Characters may have one shared Combo Craft per ally.
				{"lloyd", "tr_starblast_c", 25}, {"lloyd", "tr_starblast_c2", 50}, {"lloyd", "tr_starblast_c3", 75},
			}
			or {
				{"lloyd", "tr_starblast", 25}, {"lloyd", "tr_starblast_2", 50}, {"lloyd", "tr_starblast_3", 75},
		},
		
		strength = 50,
		magic = 52,
		endurance = 42,
		agility = 40,
		luck = 30,
		boss = true,
		thinker =     function(mo)
						if not mo.arcuslink and mo.allies and #mo.allies and #mo.allies > 1
							local targets = {}
							for i = 1, #mo.allies
								if mo.allies[i] ~= mo then targets[#targets+1] = mo.allies[i] end
							end
							return attackDefs["tr_arcus_link"], targets
						end
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,

		skin = "elie",			-- for "player" fights.
		color = SKINCOLOR_RASPBERRY,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_TAL0"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_TAL0"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_TIRE"},					-- is down
		anim_getup =		{SPR_PLAY, A, 1, "SPR2_TAL0"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_PLAY, A, 8, "SPR2_CSMN"},
		anim_evoker_shoot = {SPR_PLAY, A, 8, "SPR2_FIRE"},
		anim_special1 =		{SPR_PLAY, A, 1, "SPR2_MLEE"},
		anim_special2 =		{SPR_PLAY, A, B, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, 2, "SPR2_MLEL"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3"},
		vfx_levelup = {"sfx_elkil2"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",
		
		skills =	{
						tpBar and "tr_triple_piercer_c" or "tr_triple_piercer", "elec amp", "wind amp",
						"tr_innocence_arc", "tr_grand_stream", "tr_sylpharion", "tr_zodiac", "tr_ragna_blast", "tr_arcus_counter"
					}
}

attackDefs["tr_castprep"] = {
		name = "Preparing to Cast...",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		desc = "Trails Chars only\nPrepares to use their S-Craft.\nDoes nothing.It's just visual",
		target = TGT_CASTER,
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]

            if timer == 20
                playSound(mo.battlen, sfx_scraft)
                for i = 1,16
                    local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                    dust.angle = ANGLE_90 + ANG1* (22*(i-1))
                    dust.state = S_CDUST1
                    P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
                    dust.color = SKINCOLOR_RED
                    dust.scale = FRACUNIT*2
                end

            elseif timer > 15 and timer <= 70


                for i = 1, 8
                    local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
                    thok.sprite = SPR_SUMN
                    thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
                    thok.momz = P_RandomRange(6, 16)*FRACUNIT
                    thok.color = SKINCOLOR_RED
                    thok.tics = P_RandomRange(10, 35)
                end
            end
            if timer == 35
                BTL_logMessage(mo.battlen, mo.name.." is charging a powerful attack...")
                VFX_Play(mo, VFX_CRIT)
            elseif timer == 70
                return true
            end
        end,
    }
	
freeslot("sfx_scrft2")

/*
attackDefs["tr_scraftprep_alt"] = {
		name = "Preparing S-Craft",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		norandom = true,
		norogue = true,
		nometronome = true,			
		desc = "Trails Chars only\nPrepares to use their S-Craft.\nDoes nothing.It's just visual",
		target = TGT_CASTER,
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]

            if timer == 20
                playSound(mo.battlen, sfx_scrft2)
                for i = 1,16
                    local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                    dust.angle = ANGLE_90 + ANG1* (22*(i-1))
                    dust.state = S_CDUST1
                    P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
                    dust.color = SKINCOLOR_RED
                    dust.scale = FRACUNIT*2
                end

            elseif timer > 15 and timer <= 70


                for i = 1, 8
                    local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
                    thok.sprite = SPR_SUMN
                    thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
                    thok.momz = P_RandomRange(6, 16)*FRACUNIT
                    thok.color = SKINCOLOR_RED
                    thok.tics = P_RandomRange(10, 35)
                end
            end
            if timer == 35
                BTL_logMessage(mo.battlen, mo.name.." is charging a powerful attack...")
                VFX_Play(mo, VFX_CRIT)
            elseif timer == 70
                return true
            end
        end,
    }
*/

attackDefs["tr_grail_locket"] = {
        name = "Grail Locket",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Recover from status.",
		showsp = true,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}
			if timer == 1
				if not mo.status_condition
					return true
				else
					if mo.status_condition == COND_HYPER
						return true
					elseif mo.status_condition == COND_SUPER
						return true
					else
						cureStatus(mo)
					end
				end
			end
			
			if timer == 1
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
			end	
			
			if timer == 35
				return true
			end
		end,
	}
	

if bionis
    enemyList["enemylloyd"].weak = $|ATK_METAL|ATK_WATER
	enemyList["enemylloyd"].resist = $|ATK_EARTH
end

if bionis
    enemyList["enemylloyd2"].weak = $|ATK_METAL|ATK_WATER
	enemyList["enemylloyd2"].resist = $|ATK_EARTH
end

if bionis
    enemyList["enemyestelle"].weak = $|ATK_EARTH
	enemyList["enemyestelle"].resist = $|ATK_WATER
end	

if bionis
    enemyList["enemyestelle2"].weak = $|ATK_EARTH
	enemyList["enemyestelle2"].resist = $|ATK_WATER
end	

if bionis
	enemyList["enemyjoshua"].weak = $|ATK_FOREST
	enemyList["enemyjoshua"].resist = $|ATK_GRAVITY
end

if bionis
	enemyList["enemyjoshua2"].weak = $|ATK_FOREST
	enemyList["enemyjoshua2"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemytita"].weak = $|ATK_POISON
	enemyList["enemytita"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemytita2"].weak = $|ATK_POISON
	enemyList["enemytita2"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemyelie"].weak = $|ATK_POISON
	enemyList["enemyelie"].resist = $|ATK_FOREST
end

if bionis
    enemyList["enemyelie2"].weak = $|ATK_POISON
	enemyList["enemyelie2"].resist = $|ATK_FOREST
end
