-- events
-- this is where we can do events like in game cutscenes and dialogues and whatnot.
-- it's pretty exhaustive honestly.
-- do note that events can't run unless battlestatus has been initiated since we do rely on player inputs

rawset(_G, "evt_buffer", {})	-- I'm done with your shit coding, Lat'!


SRB2P_addHook("DungeonThinker", function() --reaper fuckery 3
	if not evt_buffer
		evt_buffer = {}
	end
end)

-- start an event
D_startEvent = function(pn, event, camstuff)
	if not server return end	-- title

	if not server.P_DialogueStatus
		D_resetDialogueStatus(pn)
	end	
	
	local evt = server.P_DialogueStatus[pn]

	if not eventList[event]
		print("Event \'"..event.."\' does not exist.")
		D_endEvent()
		return
	end
	
	if not evt 
	or (server.entrytime and server.entrytime > TICRATE/2 + 10)
	or not server.skinlist	-- players not initiated, map is subject to change at any time... yikes!
		-- buffer:
		evt_buffer[pn] = {event, camstuff}
		
		for p in players.iterate do
			if p.P_party == pn
				PLAY_nomove(p)
			end	
		end
		return
	end

	evt.event = event
	evt.eventindex = 1
	evt.timers.start = TICRATE/3

	-- initiate camera if not done already:
	if not server.P_BattleStatus[pn].cam or not server.P_BattleStatus[pn].cam.valid
		server.P_BattleStatus[pn].cam = spawnbattlecam()
	end
	if camstuff
		local cam = server.P_BattleStatus[pn].cam
		P_TeleportMove(cam, camx or 0, camy or 0, camz or 0)
		cam.angle = caman or 0
	end
end







D_RunEvents = function()
	if not server return end

	-- loading an event frame 1 of any map would actually crash, so buffer it and start it whenever we can!
	-- besides, we need to wait for the end of the potential title card before we do anything
	if evt_buffer
	and server.P_DialogueStatus
	and server.entrytime
	and (server.entrytime < TICRATE/2 + 10)
		for i = 1, 4
			if evt_buffer[i]
				D_startEvent(i, evt_buffer[i][1], evt_buffer[i][2])
			end	
		end	
		evt_buffer = {}
	end

	if not server.P_BattleStatus return end
	for i = 1, 4
		local btl = server.P_BattleStatus[i]	-- Assumption: No multiplayer cutscenes
		-- always run events, unless we're in battle in which case we let the battle handler take care of it.
		if btl and btl.running return end
		D_eventHandler(i)
	end
end


