if not srb2p return end

freeslot("MT_HTRAIL")

mobjinfo[MT_HTRAIL] = {
	-1,
	S_INVISIBLE,
	0,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	0,
	32 * FRACUNIT,
	32 * FRACUNIT,
	0,
	0,
	0,
	sfx_None,
	MF_NOBLOCKMAP|MF_NOGRAVITY,
	S_NULL
}

addHook("MobjThinker", function(mo)

	if not mo.alivefor then mo.alivefor = 1 else mo.alivefor = min(16, $+2) end

	local sx = mo.x + mo.dist*cos(mo.angle)
	local sy = mo.y + mo.dist*sin(mo.angle)

	mo.angle = $ + ANG1*P_RandomRange(6,12)


	local qualityfactor = 1
	if mo.lowquality then qualityfactor = 2 end

	if not mo.fakeangle
		mo.fakeangle = P_RandomRange(0, 359)*ANG1
	end

	for i = 1, mo.alivefor / qualityfactor
		local ref = ANG1*2 * qualityfactor

		local sx = mo.sx + mo.dist*cos(mo.angle - (ref)*i)
		local sy = mo.sy + mo.dist*sin(mo.angle - (ref)*i)

		local trail = P_SpawnMobj(sx, sy, mo.z, MT_THOK)
		trail.frame = A|FF_FULLBRIGHT|TR_TRANS50
		trail.scale = FRACUNIT/3 - (FRACUNIT/12)*(i-1) / (mo.alivefor / qualityfactor)
		trail.scalespeed = $
		trail.destscale = 1

		if mo.tics == 1
			trail.angle = mo.angle - (ref)*i + ANGLE_90
			P_InstaThrust(trail, trail.angle, FRACUNIT*30)
			trail.tics = 7
		end

		if mo.jizzcolor
			trail.color = SKINCOLOR_WHITE
		else
			trail.color = SKINCOLOR_GOLD
		end
	end
end, MT_HTRAIL)

function A_HaloSpark(mo, var1)
	local g = P_SpawnGhostMobj(mo)
	g.color = SKINCOLOR_GOLD
	g.fuse = $*3/2
	g.scale = mo.scale + FRACUNIT/2
	g.frame = $|FF_FULLBRIGHT|TR_TRANS70
	if var1
		g.destscale = 1
		g = P_SpawnGhostMobj(mo)
		g.color = SKINCOLOR_WHITE
		g.scale = mo.scale + FRACUNIT/2
		g.frame = $|FF_FULLBRIGHT|TR_TRANS70
		g.destscale = 1
	end
end

states[S_HALOBOMB] = {SPR_NTHK, C|FF_FULLBRIGHT|TR_TRANS70, 1, A_HaloSpark, 1, 0, S_HALOBOMB}