freeslot("SPR_LOWE", "SPR_LOIC", "SPR_SVTH", "sfx_silthr","sfx_swabb", "sfx_demflm", "sfx_demfl2", "sfx_ertgrd", "sfx_strslh")


BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Bladelord",
  description = {"Enforcer No. II of Ouroboros", "wants to see what you got!"},
  level = 99,
  music = "SIVWIL",
  time = TICRATE*60*59,
  items = {{"tr_tear-allbalm", 60}, {"tr_spcharge3", 40}, {"tr_curiabalm", 20}, {"tr_recuriabalm", 10}, {"tr_revbalm", 30}, {"tr_celbalm", 25}, {"hypercombiring", 40}, {"soma", 4}, {"dekaja gem", 50}, {"tr_stablet", 50}},
  waves = {
			{"loewe"},
		},
}


enemyList["loewe"] = {
		name = "Leonhardt",
		skillchance = 100,	
		level = 100,
		hp = 11000,
		sp = 9999,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		s_craft = {		--This character uses S Crafts. There are two S-Craft slots, denoted by the third number in each entry.
			{"tr_demon_flames_c", 1, 1}, {"tr_swordabbadon_c", 1, 2},
		},
		strength = 99,
		magic = 99,
		endurance = 80,
		luck = 70,
		agility = 90,
		melee_natk = "brave blade",	
		thinker =     function(mo)
						/*
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 
                            if not mo.healed 
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} 
                            elseif not mo.scraft 
                                mo.scraft = true 
                                return attackDefs["swordabbadon"], enemies
                            end    
                        end*/
                        return generalEnemyThinker(mo)
                    end,	
		thinkframe = 	function(mo)
			if mo and mo.valid
				Z_PinchMusic(mo,25,"SIVWIL","LOWHP2", true)
			end
		end,					
		boss = true,
		endboss = true,
		turns = 2,
		
		

		anim_stand = 		{SPR_LOWE, A, 4},				-- standing
		anim_stand_hurt =	{SPR_LOWE, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_LOWE, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_LOWE, A, 4},				-- guarding
		anim_move =			{SPR_LOWE, A, 4},	-- moving
		anim_run =			{SPR_LOWE, A, 4},	-- guess what
		anim_atk =			{SPR_LOWE, A, 4},			-- attacking
		anim_aoa_end =		{SPR_LOWE, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_LOWE, C, 30},				-- taking damage
		anim_getdown =		{SPR_LOWE, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LOWE, A, 4},					-- is down
		anim_getup =		{SPR_LOWE, A, 4},			-- gets up from down
		anim_death =		{SPR_LOWE, Y, 4},					-- dies
		anim_revive =		{SPR_LOWE, A, 4},			-- gets revived
		anim_evoker =		{SPR_LOWE, B, 4},
		anim_evoker_shoot = {SPR_LOWE, B, 4},
		anim_special1 =		{SPR_LOWE, D, 4},
		anim_special2 =		{SPR_LOWE, E, F, G, H, 4},
		anim_special3 =		{SPR_LOWE, H, I, J, K, L, M, N, O, P, 4},
		anim_special4 =		{SPR_LOWE, Q, R, S, T, U, V, W, X, 4},
		
		vfx_skill = {"sfx_loatk1", "sfx_loatk2", "sfx_loatk3", "sfx_loatk4"},
		vfx_hurt = {"sfx_lohrt1", "sfx_lohrt2", "sfx_lohrt3"},
		vfx_crit = {"sfx_locrt1", "sfx_locrt2", "sfx_locrt3"},
		vfx_die = {"sfx_lodead", "sfx_loded2"},
		
		hudcutin = "LOWE_A",	-- cut in
		color = SKINCOLOR_BONE,
		
		skills = C2SBarEdits and {"tr_silver_thorn", "tr_sol_eruption", "tr_earth_guard", "tr_zero_storm_c", "brave blade", "deathbound", "myriad slashes", "dekunda", "dekaja", "diamondcutter", "tr_body_split", "tr_bladelordenmap", "psy amp"}
			or {"tr_silver_thorn", "tr_sol_eruption", "tr_earth_guard", "tr_zero_storm", "brave blade", "deathbound", "myriad slashes", "dekunda", "dekaja", "diamondcutter", "tr_body_split", "tr_bladelordenmap", "psy amp"},
		
		deathanim = function(mo)

						mo.deathtimer = $ and $+1 or 1

						if mo.deathtimer == 1

							for p in players.iterate do
								if p and p.control and p.control.valid and p.control.battlen == mo.battlen
									S_FadeOutStopMusic(200, p)
								end
							end

							mo.basecoords = {mo.x, mo.y, mo.z}
							mo.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
							ANIM_set(mo, mo.anim_hurt)

							local cam = server.P_BattleStatus[mo.battlen].cam
							local destx = mo.x + 192*cos(mo.angle)
							local desty = mo.y + 192*sin(mo.angle)
							CAM_goto(cam, destx, desty, mo.z + FRACUNIT*8)
							CAM_angle(cam, R_PointToAngle2(destx, desty, mo.x, mo.y))

						elseif mo.deathtimer < TICRATE*2

							P_TeleportMove(mo, mo.basecoords[1] + P_RandomRange(-4, 4)*FRACUNIT, mo.basecoords[2] + P_RandomRange(-4, 4)*FRACUNIT, mo.basecoords[3] + P_RandomRange(-4, 4)*FRACUNIT)
							mo.anim_time = 0

						elseif mo.deathtimer == TICRATE*2
							P_TeleportMove(mo, mo.basecoords[1], mo.basecoords[2], mo.basecoords[3])
							ANIM_set(mo, mo.anim_death)
							mo.flags = $ & ~(MF_NOCLIPHEIGHT|MF_NOGRAVITY)

						elseif mo.deathtimer == TICRATE*3
							mo.hp = 1	-- hack
							mo.deathanim = nil
							D_startEvent(mo.battlen, "ev_loewedefeated")
							return	-- deref
						end
					end,
}

enemyList["cloneloewe"] = {
		name = "Leonhardt(Clone)",
		skillchance = 100,	
		level = 100,
		hp = 750,
		sp = 9999,
		barcolor = BARCOLOR_KISEKI,
		tpbar = true,	-- We use TP
		tpspuse = true,
		cpuse = true,	--Actually no, it's CP. Double capacity, but we lose all of out CP when we die.
		strength = 80,
		magic = 80,
		endurance = 60,
		luck = 50,
		agility = 80,
		melee_natk = "brave blade",	
		thinker = generalEnemyThinker,	
		thinkframe = 	function(mo)
			if mo and mo.valid
				Z_PinchMusic(mo,25,"SIVWIL","LOWHP2", true)
			end
		end,					
		boss = true,
		turns = 1,
		
		

		anim_stand = 		{SPR_LOWE, A, 4},				-- standing
		anim_stand_hurt =	{SPR_LOWE, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_LOWE, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_LOWE, A, 4},				-- guarding
		anim_move =			{SPR_LOWE, A, 4},	-- moving
		anim_run =			{SPR_LOWE, A, 4},	-- guess what
		anim_atk =			{SPR_LOWE, A, 4},			-- attacking
		anim_aoa_end =		{SPR_LOWE, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_LOWE, C, 30},				-- taking damage
		anim_getdown =		{SPR_LOWE, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LOWE, A, 4},					-- is down
		anim_getup =		{SPR_LOWE, A, 4},			-- gets up from down
		anim_death =		{SPR_LOWE, Y, 4},					-- dies
		anim_revive =		{SPR_LOWE, A, 4},			-- gets revived
		anim_evoker =		{SPR_LOWE, B, 4},
		anim_evoker_shoot = {SPR_LOWE, B, 4},
		anim_special1 =		{SPR_LOWE, D, 4},
		anim_special2 =		{SPR_LOWE, E, F, G, H, 4},
		anim_special3 =		{SPR_LOWE, H, I, J, K, L, M, N, O, P, 4},
		anim_special4 =		{SPR_LOWE, Q, R, S, T, U, V, W, X, 4},
		
		vfx_skill = {"sfx_loatk1", "sfx_loatk2", "sfx_loatk3", "sfx_loatk4"},
		vfx_hurt = {"sfx_lohrt1", "sfx_lohrt2", "sfx_lohrt3"},
		vfx_crit = {"sfx_locrt1", "sfx_locrt2", "sfx_locrt3"},
		vfx_die = {"sfx_lodead", "sfx_loded2"},
		
		hudcutin = "LOWE_A",	-- cut in
		color = SKINCOLOR_BONE,
		
		skills = C2SBarEdits and {"tr_silver_thorn", "tr_earth_guard", "tr_zero_storm_c", "brave blade", "deathbound", "myriad slashes", "dekunda", "dekaja", "diamondcutter", "psy amp"}
			or {"tr_silver_thorn", "tr_earth_guard", "tr_zero_storm", "brave blade", "deathbound", "myriad slashes", "dekunda", "dekaja", "diamondcutter", "psy amp"},		
}


attackDefs["tr_swordabbadon_c"] = {
	name = "Dead Emperor Sword",
	type = ATK_ALMIGHTY,	--ehh sure fine why not, his sword can literally break through the unbreakable.
	power = 900,
	accuracy = 100,
	costtype = CST_HP,
	cost = 0,
	hits = 1,
	strengthoverride = true,
	forcetp = true,
	notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
	scraft = true,
	norogue = true,	
	nometronome = true,
	norandom = true,
	critical = 25,
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_SCRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	desc = "Loewe's S-Craft\nFreezes the enemies and finish them\noff with a slice on the ground.",
	target = TGT_ALLENEMIES,
	norepel = true,
	anim_norepel = true,
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if charStats[mo.stats].tpspuse
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
	hudfunc = function(v, mo, timer)
				if timer >= 135 and timer < 155
					v.fadeScreen(135, min(5,(timer - 50)/2))
				elseif timer >= 155 and timer < 205
					v.fadeScreen(135, max(0,5 - max(0,((timer - 50)/6))))
				end
			end,		
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 1
			ANIM_set(mo, mo.anim_special1, true)
			playSound(mo.battlen, sfx_cutsky)
			if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
				mo.tp = 0
			else
				mo.sp = 0
			end
		end		
		
		if timer == 15
			ANIM_set(mo, mo.anim_special2)
			playSound(mo.battlen, sfx_swabb)
		end	
		
		if timer == 55
			playSound(mo.battlen, sfx_trlaur)
			playSound(mo.battlen, sfx_trlaur)
		end	
		
		if timer >= 56 and timer < 110
			summonAura(mo, SKINCOLOR_AZURE)
		end
		
		if timer == 110
			ANIM_set(mo, mo.anim_special3)
		end
		
		if timer == 127
			local s = P_SpawnMobj(mo.x, mo.y, mo.floorz, MT_GHOST)
			s.sprite = SPR_LOIC
			s.colorized = true
			s.color = SKINCOLOR_CYAN
			s.frame = A
			s.flags2 = MF2_SPLAT
			s.tics = -1
			s.fuse = 100
			s.scale = FRACUNIT/1
			playSound(mo.battlen, sfx_cocyt)
			mo.pancake = s					
		end
		
		if timer >= 135 and timer <= 180	
			if not (timer%8)
				for i = 1, 9
					local dust = P_SpawnMobj(avgx+P_RandomRange(-256, 256)*FRACUNIT, avgy+P_RandomRange(-256, 256)*FRACUNIT, mo.floorz+(5*FRACUNIT), MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale = S_BUFUDYNE_DUST1, FRACUNIT*5
					dust.destscale = FRACUNIT*10/4
					dust.scalespeed = FRACUNIT/15
					P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
					dust.momz = 5*FRACUNIT/2
				end	
			end	
		end	
		
		if timer == 140
			S_StartSound(nil, sfx_iciedg)
		end		
		
		for i = 1,#hittargets
			local target = hittargets[i]
			if timer == 142 + 8*(i-1)
				local ice = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				ice.sprite = SPR_FHZI
				ice.frame = B
				ice.scale = 1
				ice.destscale = target.scale
				ice.tics = 40
				playSound(mo.battlen, sfx_bufu3)
			end
			if timer == 144 + 8*(i-1)
				local iceghost = P_SpawnGhostMobj(target)
				iceghost.fuse = 40
				iceghost.colorized = true
				iceghost.color = SKINCOLOR_ICY	
				iceghost.frame = target.frame
			end	
		end	
		
		if timer == 145
			playSound(mo.battlen, sfx_bufu5)
		end
		
		if timer == 189
			ANIM_set(mo, mo.anim_special4)
			VFX_Play(mo, VFX_SKILL)
		end
		
		if timer == 199
			playSound(mo.battlen, sfx_bufu2)
			playSound(mo.battlen, sfx_bexpld)
			playSound(mo.battlen, sfx_slash)
		end	
		
		if timer == 210
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 10, 5)
				end
			end
		end		
		
		if timer == 211
			playSound(mo.battlen, sfx_eethit)
			playSound(mo.battlen, sfx_bufu6)
			P_StartQuake(FRACUNIT*50, 10)
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i

				local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end
		
		if timer == 212
			playSound(mo.battlen, sfx_bufu5)
			for i = 1, P_RandomRange(17, 32)
				local ba = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
				ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
			end
			for i = 1, P_RandomRange(11, 32)
				local bb = P_SpawnMobj(avgx+(P_RandomRange(-50, 50)*FRACUNIT), avgy+(P_RandomRange(-50, 50)*FRACUNIT), mo.z+(P_RandomRange(0, 128)*FRACUNIT), MT_BUFU_PARTICLE)
				bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
				bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
			end
			for i = 1, 9
				local curangle = ANG1*40*i

				local dust = P_SpawnMobj(avgx+(24*cos(curangle)), avgy+(24*sin(curangle)), mo.z, MT_DUMMY)
				dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
				dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
				dust.destscale = FRACUNIT*5/2
				dust.scalespeed = FRACUNIT/18
				P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
				dust.momz = 4*FRACUNIT
			end	
		end		
			
			
		for k,v in ipairs(hittargets)
			if timer == 211
				damageObject(v)
			end
		end
		if timer == 230
			mo.pancake = nil
			return true
		end		
		
		if mo.pancake
		and mo.pancake.valid 
			mo.pancake.scale = min(FRACUNIT*6,$ + FRACUNIT/5)
		end						
	end,
}	


attackDefs["tr_zero_storm"] = {
	name = "Zero Storm",
	type = ATK_ALMIGHTY,
	power = 700,
	accuracy = 95,
	costtype = CST_HPPERCENT,
	cost = 20,		
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	desc = "Sends a straight cyclone that breaks barriers\n causing Severe Almighty Damage",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT		
		
		if timer == 1
			mo.oldangle = mo.angle
			mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)				
		end		
		
		if timer == 10
			playSound(mo.battlen, sfx_caledg)
		end	

		if timer >= 10 and timer < 60
			summonAura(mo, SKINCOLOR_WHITE)
		end
			
		if timer >= 10 and timer <= 60
			for i = 1,3
				local thok = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_BONE
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 20)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
		end		
	

		if timer == 61
			S_StartSound(nil, sfx_gallan)
		end	
		
		if timer >= 61
		and timer <= 100
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.frame = A|FF_FULLBRIGHT
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*5
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
				localquake(mo.battlen, FRACUNIT*10, 10)
			end
		end	
		
		if timer >= 61
		and timer <= 100
			if leveltime%2 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.sprite = SPR_SLAS
				d.color = SKINCOLOR_AETHER
				d.blendmode = AST_ADD
				d.frame = I|TR_TRANS50 + P_RandomRange(0, 3)|FF_FULLBRIGHT
				d.angle = mo.angle + ANG1*90
				d.scale = FRACUNIT*9
				d.tics = TICRATE/3
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
			end
		end
		
		if timer == 90
			playSound(mo.battlen, sfx_eethit)
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer == 110 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["tr_zero_storm_c"] = {
	name = "Zero Storm",
	type = ATK_ALMIGHTY,
	power = 700,
	accuracy = 95,
	costtype = CST_SP,
	cost = 30,	
	strengthoverride = true,
	forcetp = true,	
	custombackground = function(v, x, y, atk_color, mo) --changes the atk background and icons
		PDraw(v, x+3, y+3, v.cachePatch("TR_CRAFT"), V_SNAPTOLEFT)
		PDraw(v, x, y, v.cachePatch("H_ATKBG"), V_SNAPTOLEFT, v.getColormap(TC_DEFAULT, atk_color))
	end,
	desc = "Sends a straight cyclone that breaks barriers\n causing Severe Almighty Damage",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT		
		
		if timer == 1
			mo.oldangle = mo.angle
			mo.angle = R_PointToAngle2(mo.x, mo.y, avgx, avgy)				
		end		
		
		if timer == 10
			playSound(mo.battlen, sfx_caledg)
		end	

		if timer >= 10 and timer < 60
			summonAura(mo, SKINCOLOR_WHITE)
		end
			
		if timer >= 10 and timer <= 60
			for i = 1,3
				local thok = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_BONE
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 20)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
		end		
	

		if timer == 61
			S_StartSound(nil, sfx_gallan)
		end	
		
		if timer >= 61
		and timer <= 100
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.frame = A|FF_FULLBRIGHT
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*5
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
				localquake(mo.battlen, FRACUNIT*10, 10)
			end
		end	
		
		if timer >= 61
		and timer <= 100
			if leveltime%2 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.sprite = SPR_SLAS
				d.color = SKINCOLOR_AETHER
				d.blendmode = AST_ADD
				d.frame = I|TR_TRANS50 + P_RandomRange(0, 3)|FF_FULLBRIGHT
				d.angle = mo.angle + ANG1*90
				d.scale = FRACUNIT*9
				d.tics = TICRATE/3
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
			end
		end
		
		if timer == 90
			playSound(mo.battlen, sfx_eethit)
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer == 110 + 10*(#hittargets-1)
			return true
		end	
	end,
}

attackDefs["tr_demon_flames_c"] = {
	name = "Demon Flames",
	type = ATK_SLASH,
	power = 600,
	accuracy = 100,
	costtype = CST_SP,
	cost = 0,
	strengthoverride = true,
	forcetp = true,
	notpgain = true,	--you'd nigh-instantly refill the meter with this much power!
	scraft = true,
	norogue = true,	
	nometronome = true,
	norandom = true,
	hits = 2,
	critical = 10,
	norepel = true,
	anim_norepel = true,
	desc = "Heavy Slash damage to \nall enemies up to 2 times.",
	target = TGT_ALLENEMIES,
				nocast = 	function(targets, n, mo)	-- we can't cast this skill if this function returns true
						if not charStats[mo.stats].tpbar or not charStats[mo.stats].cpuse
							BTL_logMessage(targets[1].battlen, "You can't use this skill.")
							return true
						end
						if charStats[mo.stats].tpspuse
							if mo.tp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						else
							if mo.sp < 100
								BTL_logMessage(targets[1].battlen, "Insufficient Craft Points.")
								return true
							end
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local avgx, avgy = 0, 0
		for i = 1, #targets
			avgx = $ + targets[i].x/FRACUNIT
			avgy = $ + targets[i].y/FRACUNIT
		end
		avgx = ($/#targets)	*FRACUNIT
		avgy = ($/#targets)	*FRACUNIT
		
		if timer == 1
			playSound(mo.battlen, sfx_cutsky)
			if mo.tpspuse or (mo.stats and charStats[mo.stats].tpspuse) or (mo.enemy and enemyList[mo.enemy].tpspuse)
				mo.tp = 0
			else
				mo.sp = 0
			end
		end	
	
		if timer >= 10 and timer < 60
			summonAura(mo, SKINCOLOR_FLAME)
		end	
		
		if timer > 10
		and timer <= 60
			if not (leveltime%5)
				mo.z_dangle = P_RandomRange(1, 359)*ANG1 -- default angle we'll base the second zio on
				local dist = 36+P_RandomRange(-50, 50)

				local z1 = P_SpawnMobj(mo.x+(dist*cos(mo.z_dangle)), mo.y+(dist*sin(mo.z_dangle)), mo.floorz, MT_DUMMY)
				z1.state, z1.scale, z1.color = S_LZIO11, mo.scale*9/4, SKINCOLOR_FLAME
				z1.destscale = mo.scale
				local z2 = P_SpawnMobj(mo.x+(dist*cos(mo.z_dangle)), mo.y+(dist*sin(mo.z_dangle)), mo.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, mo.scale*9/4, SKINCOLOR_FLAME
				z2.destscale = mo.scale	
			end		
		end	
		
		if timer == 10
			playSound(mo.battlen, sfx_demflm)
			playSound(mo.battlen, sfx_zio5)
		end
		
		if timer == 60
			playSound(mo.battlen, sfx_demfl2)
		end	
		

		if timer >= 90 and timer <= 100
			local bs = P_SpawnMobj(avgx+ P_RandomRange(20, 20)*FRACUNIT, avgy+ P_RandomRange(20, 20)*FRACUNIT, mo.z, MT_BUFU)
			bs.state = S_QUICKBOOM1
			bs.scale = FRACUNIT*3
			bs.momz = P_RandomRange(-1, 1)*FRACUNIT
		end	
		
		if timer == 90
		or timer == 92
		or timer == 94
		or timer == 96

			if timer == 90
				playSound(mo.battlen, sfx_fire2)
				playSound(mo.battlen, sfx_strslh)
				playSound(mo.battlen, sfx_slash)
				playSound(mo.battlen, sfx_slash)
			end
			local ang = 0
			for i = 1, 24 do

				local f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				f.state = S_FLAME
				f.scale = FRACUNIT/2
				f.fuse = TICRATE
				f.destscale = FRACUNIT*4
				f.friction = FRACUNIT
				f.angle = ang
				P_InstaThrust(f, f.angle, 50*FRACUNIT)

				f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				f.state = S_QUICKBOOM1
				f.scale = FRACUNIT
				f.fuse = TICRATE
				f.friction = FRACUNIT
				f.destscale = FRACUNIT*4
				f.angle = ang
				f.color = SKINCOLOR_RED
				P_InstaThrust(f, f.angle, 60*FRACUNIT)

				for i = 1, 8
					f = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					f.state = S_SPINFIRE1
					f.fuse = TICRATE
					f.friction = FRACUNIT
					f.scale = FRACUNIT/2
					f.destscale = FRACUNIT*4
					f.angle = ang + P_RandomRange(-15, 15)*ANG1
					P_InstaThrust(f, f.angle, 50*FRACUNIT + P_RandomRange(-16, 16)*FRACUNIT)
				end
				ang = $ + (360/24)*ANG1
			end
		end		
		
		if timer == 92
		or timer == 95
			for k,v in ipairs(hittargets)
				damageObject(v)
			end
		end
		
		if timer == 110 
			return true
		end					
	end,
}	

attackDefs["tr_body_split"] = {
		name = "Body Split",
		type = ATK_ALMIGHTY,
		power = 0,
		accuracy = 999,
		costtype = CST_HPPERCENT,
		cost = 0,
		nometronome = true,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		desc = "Creates a clone of yourself.",
		target = TGT_CASTER,
		anim = function(mo, targets, hittargets, timer)

			/*if mo.plyr
				BTL_logMessage(mo.battlen, "No seriously don't use this on players you absolute idiot!!")
				return true	-- JUST IN CASE /!\
				-- Let's be chaotic evil, let players do this at their own expense :)
			end*/
			local cam = server.P_BattleStatus[mo.battlen].cam

			if timer == 1
				mo.replica = BTL_spawnEnemy(mo, "cloneloewe")

				if mo.replica == nil	-- failure?
					return true
				end

				local target = mo.replica
				mo.replica.flags2 = $|MF2_DONTDRAW

				mo.replica.hp = 750

				local an = ANG1* P_RandomRange(10, 35)
				local gox,goy

				gox = target.x + 300*cos(target.angle+an)
				goy = target.y + 300*sin(target.angle+an)

				--P_TeleportMove(cam, gox, goy, target.z + FRACUNIT*40)	-- teleport the camera to a nice spot
				CAM_goto(cam, gox, goy, target.z + FRACUNIT*40)
				CAM_angle(cam, R_PointToAngle2(gox, goy, target.x, target.y))
				CAM_aiming(cam, 0)
			end
			-- spawns a new angel in the fight.

			if timer >= 1
			and timer <= TICRATE/2
			and leveltime & 1

				mo.replica.flags2 = $ & ~MF2_DONTDRAW
				local g = P_SpawnGhostMobj(mo.replica)
				mo.replica.flags2 = $|MF2_DONTDRAW
				g.colorized = true
				g.fuse = 2
			end

			if timer == TICRATE/2

				mo.replica.flags2 = $ & ~MF2_DONTDRAW
				local g = P_SpawnGhostMobj(mo.replica)
				g.colorized = true
				g.destscale = FRACUNIT*4
				S_StartSound(replica, sfx_kdist)

			end

			if timer == TICRATE
				mo.replica = nil
				BTL_normalizePositions(mo.allies, true)	--prevents them from visually stacking
				return true
			end
		end,
	}


attackDefs["tr_bladelordenmap"] = {
        name = "Loewe's Map Loader",
        type = ATK_PASSIVE,
        desc = "Forces the map to change on the vision quest",
        passive = PSV_STARTBATTLE,
        anim = function(mo, targets, hittargets, timer)
            if G_BuildMapName() ~= "MAP48" //Nothing in () makes it check current map
                COM_BufInsertText(server, "map 48 -f") //Sends you to brazil... Maybe, literally?
            end //We didn't return true?!?! That's because PSV_STARTBATTLE only activates for ONE frame, and dont need no stinkn' returns
        end,
}

VFX_freeslotE("loewe")