rawset(_G, "Z_PinchMusic", function(mo, health, defaultmusic, pinchmusic, swaptracks, onecall)

	if mo and mo.valid
		
		if mo.playerpinchmusicerror
			return false //Error....
		end
		
		local failure = false
		
		if not health//health is the value where ost changes, in % of team HP remaining
			dprint("! Z_PinchMusic called with no health value.")
			failure = true
		end
		
		if not defaultmusic//defaultmusic is... Default music
			dprint("! Z_PinchMusic called with no defaultmusic value.")
			failure = true
		end
		
		if not pinchmusic//pinchmusic is what it'll change
			dprint("! Z_PinchMusic called with no pinchmusic value.")
			failure = true
		end
		
		if failure
			dprint("Please check "..mo.name.."'s ThinkFrame! Preventing any more Z_PinchMusic calls...")
			mo.playerpinchmusicerror = true
			return false
		end
		
		//onecall will prevent the thinker running after being swapped once
		

		
		
		local allenm = mo.enemies_noupdate//A special table which never changes.
		local fullhp = 0//DEFINE this here so it can be called outta loop
		local teamhp = 0//As above.
		
		for i = 1,#allenm//So, for every enemy, or 'team member' we the players have..
			local member = allenm[i]//This loop's specific member
			fullhp = $ + member.maxhp//The highest HP this member can have
			teamhp = $ + member.hp//And the current HP this member has. Even includes dead 0 HP
		end
		
		//So, we now have the collective HP of the team, including those who got pancake treatment and were bonked outta existance

		//Change this if below for the appropriate values
		
		local healthcheck = false
		
		if teamhp < (fullhp*health)/100
			healthcheck = true
		end
		
		if healthcheck
			if not mo.playerpinchmusic//We check this so we don't infinitely call this music
				if S_MusicName() == defaultmusic//AND uhhh whilst we're at it, make sure it's the right track anyways... Ppl can use Tunes or other music changes!!
					if swaptracks
						local trackswap = S_GetMusicPosition()//Current position for seemless swapping!
						S_ChangeMusic(pinchmusic, true, nil, nil, trackswap)//Change music, let it loop, nil to play all, I don't know what music flags are for, aaaaaand start it from where it was!
					else
						S_ChangeMusic(pinchmusic, true)
					end
				end
				mo.playerpinchmusic = true//Those things up there are local client only, so lets not allow this variable be determined by that, and just enable anyways
				if onecall//no more!
					mo.playerpinchmusicerror = true
				end
				return true //why not
			end
		else//We have health% or above
			if mo.playerpinchmusic
				if S_MusicName() == pinchmusic//We DO have the pinch music too, right?
					if swaptracks
						local trackswap = S_GetMusicPosition()//Aww yeah music
						S_ChangeMusic(defaultmusic, true, nil, nil, trackswap)//Go back, we healthy again!
					else
						S_ChangeMusic(defaultmusic, true)
					end
				end
				mo.playerpinchmusic = false//Local Clients might desynch alot if this was checked in music name...
			end
		end//Yeah that's all there is to it
	else
		error("Z_PinchMusic called with errors to the 'mo' value. Please check 'if mo and mo.valid' in the ThinkFrame before this function.")
	end
end)