freeslot("sfx_likatk", "sfx_likdo", "sfx_arcdrn" ,"SPR_ZODI", "sfx_zodiac", "sfx_zodac2", "SPR_ADSL", "sfx_adashd",
"sfx_terall", "sfx_teral2", "sfx_trlzip", "sfx_trlzap", "sfx_trpzap", "sfx_trsyar", "sfx_trsygr", "sfx_trptsp",
"sfx_trspfl", "sfx_trshsp", "sfx_trwhgh", "sfx_trprep", "sfx_trcast", "sfx_trgect", "sfx_trpts2", "sfx_trscrs",
"sfx_trpbrt", "sfx_trrzap", "sfx_traham", "sfx_trzap", "sfx_trgai1", "sfx_trgai2", "sfx_trpcld", "sfx_trtror",
"sfx_trdbl1", "sfx_trdbl2", "sfx_traprm", "sfx_trcbls")


------{ Thinker Funnies }------



local function tr_castaura(mo)
	if not mo or not mo.valid return end
	local btl = server.P_BattleStatus[mo.battlen]
	if btl and btl.running --only in battle
	and mo.t_act ~= ACT_ITEM	--make sure we're casting an orbal art ourselves and not with an expendable item.
		if btl.turnorder[1] == mo and (btl.battlestate == BS_DOTURN or mo.cutin)-- "It's my turn!"
			if mo.attack and mo.attack.tr_orbal -- Orbal Casting
				if not mo.tr_castaura
					mo.tr_castaura = true
					if not (mo.tr_castsound and mo.tr_castsound > 0)
						mo.tr_castsound = 50
						playSound(mo.battlen, sfx_trprep)
					end
				end
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 48
				for i = 0, 4
					local angle = baseangle + i*30*ANG1
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_FOREST
					--aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					--aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(6, 10)*FRACUNIT
					aura.scale = FRACUNIT*2
					aura.destscale = FRACUNIT/12
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(-4, -8))
				end
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 36
				for i = 0, 12
					local angle = baseangle + i*12*ANG1
					local x, y = mo.x + dist*cos(angle), mo.y + dist*sin(angle)

					local aura = P_SpawnMobj(x, y, mo.floorz + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					--if not aura or not aura.valid continue end
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_TEAL
					aura.frame = FF_FULLBRIGHT
					aura.blendmode = AST_ADD
					aura.renderflags = $|RF_FULLBRIGHT
					aura.momz = P_RandomRange(8, 12)*FRACUNIT
					aura.scale = FRACUNIT/2
					--aura.destscale = FRACUNIT*2
					--P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(1, 1))
				end
			else
				if mo.tr_castaura
					mo.tr_castaura = false
				end
			end
		elseif btl.turnorder[1] == mo and (btl.battlestate == BS_ACTION and btl.atktimer)-- "Attack!"
			if mo.attack and mo.attack.tr_orbal and mo.tr_castaura
				mo.tr_castaura = false
				mo.tr_castsound = 0
				--btl.atktimer = -15
				playSound(mo.battlen, sfx_trcast)
			end
		end
		if mo.tr_castsound and mo.tr_castsound > 0 then mo.tr_castsound = $-1 end
	end
end

addHook("MobjThinker", tr_castaura, MT_PFIGHTER)






























